<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * mailbox_display.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This contains functions that display mailbox information, such as the
 * table row that has sender, date, subject, etc...
 *
 * $Id: mailbox_display.php,v 1.3 2004/02/25 14:21:22 marco Exp $
 */

if (!defined('SM_PATH')) { define('SM_PATH','../'); }

require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'class/html.class.php');
require_once(SM_PATH . 'functions/imap_mailbox.php');
require_once(SM_PATH . 'functions/global.php');   
require_once(SM_PATH . 'functions/forms.php');   

sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );   

global $custom_css;

function elapsed($start)
{
   $end = microtime();
   list($start2, $start1) = explode(" ", $start);
   list($end2, $end1) = explode(" ", $end);
   $diff1 = $end1 - $start1;
   $diff2 = $end2 - $start2;
   if( $diff2 < 0 ){
       $diff1 -= 1;
       $diff2 += 1.0;
   }
   return $diff2 + $diff1;
}

function printMessageInfo($imapConnection, $t, $not_last=true, $key, $mailbox,
                          $start_msg, $where, $what) {
    global $checkall, $custom_css, $bse_uri, $max_char_obj_m,
           $color, $msgs, $msort, $td_str, $msg, 
           $default_use_priority,$squirrelmail_plugin_hooks,
           $message_highlight_list,
           $index_order,
           $indent_array,   /* indent subject by */
           $pos,            /* Search postion (if any)  */
           $thread_sort_messages, /* thread sorting on/off */
           $server_sort_order, /* sort value when using server-sorting */
           $row_count,$base_uri,$thread_symbol,
	   $view_read_body_main_page,
           $allow_server_sort; /* enable/disable server-side sorting */
    $color_string = $color[4];

    if ($GLOBALS['alt_index_colors']) {
        if (!isset($row_count)) {
            $row_count = 0;
        }
        $row_count++;
        if ($row_count % 2) {
            if (!isset($color[12])) {
                $color[12] = '#EAEAEA';
            }
            $color_string = $color[12];
        }
    }
    $msg = $msgs[$key];

    if($mailbox == 'None') {
        $boxes   = sqimap_mailbox_list($imapConnection);
        $mailbox = $boxes[0]['unformatted'];
        unset($boxes);
    }
    $urlMailbox = urlencode($mailbox);

    if (handleAsSent($mailbox)) {
       $msg['FROM'] = $msg['TO'];
    }
    $msg['FROM'] = parseAddress($msg['FROM'],1);
    
       /*
        * This is done in case you're looking into Sent folders,
        * because you can have multiple receivers.
        */

    $senderNames = $msg['FROM'];
    $senderName  = '';
    if (sizeof($senderNames)){
        foreach ($senderNames as $senderNames_part) {
            if ($senderName != '') {
                $senderName .= ', ';
            }
            if ($senderNames_part[1]) {
                $senderName .= $senderNames_part[1];
            } else {
                $senderName .= $senderNames_part[0];
            }
        }
    }

    $onclick = 'parent.SelectMessage('.$msg['ID'].',\'read_body.php?mailbox='.$urlMailbox.'&startMessage='.$start_msg.'&passed_id='.$msg['ID'].'\');';
    if (!$view_read_body_main_page) {
	$onclick .= ' parent.OpenPrintMessage('.$msg['ID'].',\''.$urlMailbox.'\','.$start_msg.')';
    }

    $style = "";
    if (isset($msg['FLAG_FLAGGED']) && ($msg['FLAG_FLAGGED'] == true)) {
	$style .= "color:$color[2];";
    }
    if (!isset($msg['FLAG_SEEN']) || ($msg['FLAG_SEEN'] == false)) {
	$style .= "font-weight:bold;";
    }
    if (handleAsSent($mailbox)) {
	$style .= "font-style:italic;";
    }
    if (isset($msg['FLAG_DELETED']) && $msg['FLAG_DELETED']) {
	$style .= "color:$color[9];";
    }
    if ($style) { $style = "style='$style'"; }

    if ($where && $what) {
        $searchstr = '&where='.$where.'&what='.$what;
    } else {
        $searchstr = '';
    }
    
    if (is_array($message_highlight_list) && count($message_highlight_list)) {
        $msg['TO'] = parseAddress($msg['TO']);
        $msg['CC'] = parseAddress($msg['CC']);
        foreach ($message_highlight_list as $message_highlight_list_part) {
            if (trim($message_highlight_list_part['value']) != '') {
                $high_val   = strtolower($message_highlight_list_part['value']);
                $match_type = strtoupper($message_highlight_list_part['match_type']);
                if($match_type == 'TO_CC') {
                    $match = array('TO', 'CC');
                } else {
                    $match = array($match_type);
                }
                foreach($match as $match_type) {
                    switch($match_type) {
                        case('TO'):
                        case('CC'):
                        case('FROM'):
                            foreach ($msg[$match_type] as $address) {
                                $address[0] = decodeHeader($address[0], true, false);
                                $address[1] = decodeHeader($address[1], true, false);
                                if (strstr('^^' . strtolower($address[0]), $high_val) ||
                                    strstr('^^' . strtolower($address[1]), $high_val)) {
                                    $hlt_color = $message_highlight_list_part['color'];
                                    break 4;
                                }
                            }
                            break;
                        default:
                            $headertest = strtolower(decodeHeader($msg[$match_type], true, false));
                            if (strstr('^^' . $headertest, $high_val)) {
                                $hlt_color = $message_highlight_list_part['color'];
                                break 3; 
                            }
                            break;
                    }
                }
            }
        }
    }

    if (!isset($hlt_color)) {
        $hlt_color = $color_string;
    }

    echo '<tr '.$style.' class="handcursor" id="tr'.$msg['ID'].'" bgcolor="'.$hlt_color.'" onDblClick="parent.OpenPrintMessage('.$msg['ID'].',\''.$urlMailbox.'\','.$start_msg.');" onClick="'.$onclick.'" valign=top>';

    $checked = ($checkall == 1) ? TRUE : FALSE;
    $col = 0;
    $senderName = decodeHeader($senderName);
    $senderName = decodeHTML($senderName);
    $senderName = processSender($senderName);
    $senderName = codeHTML($senderName);

    $subject = decodeHeader($msg['SUBJECT']);
    $subject = decodeHTML($subject);
    $subject = processSubject($subject, $indent_array[$msg['ID']],$max_char_obj_m);
    $subject = codeHTML($subject);
    
    if (sizeof($index_order)) {
        foreach ($index_order as $index_order_part) {
            switch ($index_order_part) {
            case 1: /* checkbox */
		echo '<td align="center" width="20">'.addCheckBox('msg['.$t.']', $checked, $msg['ID'],'onclick="event.cancelBubble=true"').'</td>';
                break;
            case 2: /* from */
		$td_str=$senderName;
		if (!$td_str) { $td_str = "&nbsp;"; }
		echo '<td width="25%" nowrap=1>'.$td_str.'</td>';
                break;
            case 3: /* date */
                $date_string = $msg['DATE_STRING'] . '';
                if ($date_string == '') { $date_string = _("Unknown date"); }
		$td_str=$date_string;
		if (!$td_str) { $td_str = " "; }
		echo '<td nowrap=1 width="10%">'.codeHTML($td_str).'</td>';
                break;
            case 4: /* subject */
		$td_str="";
                if ($thread_sort_messages == 1) {
                    if (isset($indent_array[$msg['ID']])) {
                        $td_str = str_repeat($thread_symbol,$indent_array[$msg['ID']]);
                    }
                }
                $td_str .= "$subject";
		if (!$td_str) { $td_str = " "; }
		echo '<td>'.$td_str.'</td>';
                break;
            case 5: /* flags */
                $stuff = false;
                $td_str = "";
		    $msg_icon = '';
		    $msg_title='';
            	    if (!isset($msg['FLAG_SEEN']) || ($msg['FLAG_SEEN']) == false) {
                	$msg_title = _('(New)');
                	$msg_icon .= $base_uri.'images/'.$custom_css.'/msg_new';
            	    } else {
                	$msg_title = _('(Read)');
                	$msg_icon .= $base_uri."images/".$custom_css."/msg_read";
            	    }
		    $td_str .= '<IMG id="img'.$msg['ID'].'" SRC="' . $msg_icon . '.gif" border="0" title="' .$msg_title . '" >';
                if (!$stuff) {
                    $td_str .= '&nbsp;';
                }
                do_hook("msg_envelope");
                echo html_tag( 'td',
                               $td_str,
                               'center',
                               '',
                               'nowrap=1 width="20"' );
                break;
            case 6: /* size */
		$td_str= show_readable_size($msg['SIZE']);
		if (!$td_str) { $td_str = " "; }
		echo '<td nowrap=1 width="10%" align="right">'.$td_str.'</td>';
                break;
            case 7: /* priority */
                if ($default_use_priority) {
                    if ( ($msg['PRIORITY'] == 1) || ($msg['PRIORITY'] == 2) ) {
			$td_str = '<IMG SRC="'.$base_uri.'images/'.$custom_css.'/prio_high.gif" border="0"> '; 
                    } else if ( ($msg['PRIORITY'] == 5) ) {
			$td_str = '<IMG SRC="'.$base_uri.'images/'.$custom_css.'/prio_low.gif" border="0"> '; 
                    } else {
			$td_str = '<IMG SRC="'.$base_uri.'images/'.$custom_css.'/transparent.gif" border="0" width="5"> ';
                    }
                }
                echo html_tag( 'td',$td_str,'center','','nowrap=1 width="20"' );
                break;
            case 8: /* attach */
                if ($msg['TYPE0'] == 'multipart') {
		    $td_str = '<IMG SRC="'.$base_uri.'images/'.$custom_css.'/attach.gif" border="0">'; 
                } else {
		    $td_str = '<IMG SRC="'.$base_uri.'images/'.$custom_css.'/transparent.gif" border="0" width="6">';
		}
                echo html_tag( 'td',$td_str,'center','','nowrap=1 width="20"' );
                break;
            }
            ++$col;
        }
    }
    if ($not_last) {
        echo '</tr>' . "\n" . '<tr><td COLSPAN="' . $col . '" HEIGHT="1"></td></tr>' . "\n";
    } else {
        echo '</tr>'."\n";
    }
}

function getServerMessages($imapConnection, $start_msg, $show_num, $num_msgs, $id) {
    if ($id != 'no') {
        $id = array_slice($id, ($start_msg-1), $show_num);
        $end = $start_msg + $show_num - 1;
        if ($num_msgs < $show_num) {
            $end_loop = $num_msgs;
        } else if ($end > $num_msgs) {
            $end_loop = $num_msgs - $start_msg + 1;
        } else {
            $end_loop = $show_num;
        }
        return fillMessageArray($imapConnection,$id,$end_loop,$show_num);
    } else {
        return false;
    }
}

function getThreadMessages($imapConnection, $start_msg, $show_num, $num_msgs) {
    $id = get_thread_sort($imapConnection);
    return getServerMessages($imapConnection, $start_msg, $show_num, $num_msgs, $id);
}

function getServerSortMessages($imapConnection, $start_msg, $show_num,
                               $num_msgs, $server_sort_order, $mbxresponse) {
    $id = sqimap_get_sort_order($imapConnection, $server_sort_order,$mbxresponse);
    return getServerMessages($imapConnection, $start_msg, $show_num, $num_msgs, $id);
}

function getSelfSortMessages($imapConnection, $start_msg, $show_num,
                              $num_msgs, $sort, $mbxresponse) {
    $msgs = array();
    if ($num_msgs >= 1) {
        $id = sqimap_get_php_sort_order ($imapConnection, $mbxresponse);
        if ($sort < 6 ) {
            $end = $num_msgs;
            $end_loop = $end;
	    /* set shownum to 999999 to fool sqimap_get_small_header_list
	       and rebuild the msgs_str to 1:* */
	    $show_num = 999999;
        } else {
            /* if it's not sorted */
            if ($start_msg + ($show_num - 1) < $num_msgs) {
                $end_msg = $start_msg + ($show_num - 1);
            } else {
                $end_msg = $num_msgs;
            }
            if ($end_msg < $start_msg) {
                $start_msg = $start_msg - $show_num;
                if ($start_msg < 1) {
                    $start_msg = 1;
                }
            }
            $id = array_slice(array_reverse($id), ($start_msg-1), $show_num);
            $end = $start_msg + $show_num - 1;
            if ($num_msgs < $show_num) {
                $end_loop = $num_msgs;
            } else if ($end > $num_msgs) {
                $end_loop = $num_msgs - $start_msg + 1;
            } else {
                $end_loop = $show_num;
            }
        }
        $msgs = fillMessageArray($imapConnection,$id,$end_loop, $show_num);
    }
    return $msgs;
}



/*
 * This function loops through a group of messages in the mailbox
 * and shows them to the user.
 */
function showMessagesForMailbox($imapConnection, $mailbox, $num_msgs,
                                $start_msg, $sort, $color, $show_num,
                                $use_cache, $mode='') {
    global $msgs, $msort, $auto_expunge, $thread_sort_messages,$squirrelmail_plugin_hooks, $base_uri,
           $allow_server_sort, $server_sort_order, $select_message_onclick, $reload_tree_folder_on_action, 
	    $compose_height, $compose_width, $custom_css;

    /*
     * For some reason, on PHP 4.3+, this being unset, and set in the session causes havoc
     * so setting it to an empty array beforehand seems to clean up the issue, and stopping the
     * "Your script possibly relies on a session side-effect which existed until PHP 4.2.3" error
     */
    if (!isset($msort)) {
        $msort = array();
    }

    if (!isset($msgs)) {
        $msgs = array();
    }

    //$start = microtime();
    /* If autoexpunge is turned on, then do it now. */
    $mbxresponse = sqimap_mailbox_select($imapConnection, $mailbox);
    $srt = $sort;
    /* If autoexpunge is turned on, then do it now. */
    if ($auto_expunge == true) {
        $exp_cnt = sqimap_mailbox_expunge($imapConnection, $mailbox, false, '');
        $mbxresponse['EXISTS'] = $mbxresponse['EXISTS'] - $exp_cnt;
        $num_msgs = $mbxresponse['EXISTS'];
    }

    if ($mbxresponse['EXISTS'] > 0) {
        /* if $start_msg is lower than $num_msgs, we probably deleted all messages
         * in the last page. We need to re-adjust the start_msg
         */

        if($start_msg > $num_msgs) {
            $start_msg -= $show_num;
            if($start_msg < 1) {
                $start_msg = 1;
            }
        }

        /* This code and the next if() block check for
         * server-side sorting methods. The $id array is
         * formatted and $sort is set to 6 to disable
         * SM internal sorting
         */

        if ($thread_sort_messages == 1) {
            $mode = 'thread';
        } elseif ($allow_server_sort == 1) {
            $mode = 'serversort';
        } else {
            $mode = '';
        }

	if ($use_cache) {
	    sqgetGlobalVar('msgs', $msgs, SQ_SESSION);
	    sqgetGlobalVar('msort', $msort, SQ_SESSION);
	} else {
    	    sqsession_unregister('msort');
    	    sqsession_unregister('msgs');
	}
        switch ($mode) {
            case 'thread':
                $id   = get_thread_sort($imapConnection);
                $msgs = getServerMessages($imapConnection, $start_msg, $show_num, $num_msgs, $id);
                if ($msgs === false) {
                    echo '<b><small><center><font color=red>' .
                         codeHTML(_("Thread sorting is not supported by your IMAP server.<br>Please report this to the system administrator.")).
                         '</center></small></b>';
                    $thread_sort_messages = 0;
                    $msort = $msgs = array();
                } else {
                    $msort= $msgs;
                    $sort = 6;
                }
                break;
            case 'serversort':
                $id   = sqimap_get_sort_order($imapConnection, $sort, $mbxresponse);
                $msgs = getServerMessages($imapConnection, $start_msg, $show_num, $num_msgs, $id);
                if ($msgs === false) {
                    echo '<b><small><center><font color=red>' .
                         codeHTML(_( "Server-side sorting is not supported by your IMAP server.<br>Please report this to the system administrator.")).
                         '</center></small></b>';
                    $sort = $server_sort_order;
                    $allow_server_sort = FALSE;
                    $msort = $msgs = array();
                    $id = array();
                } else {
                    $msort = $msgs;
                    $sort = 6;
                }
                break;
            default:
                if (!$use_cache) {
                    $msgs = getSelfSortMessages($imapConnection, $start_msg, $show_num,
                                                $num_msgs, $sort, $mbxresponse);
                    $msort = calc_msort($msgs, $sort);
                } /* !use cache */
                break;
        } // switch
        sqsession_register($msort, 'msort');
        sqsession_register($msgs,  'msgs');

    } /* if exists > 0 */

    $res = getEndMessage($start_msg, $show_num, $num_msgs);
    $start_msg = $res[0];
    $end_msg   = $res[1];

    $paginator_str = get_paginator_str($mailbox, $start_msg, $end_msg, $num_msgs, $show_num, $sort,$mailbox);

    $msg_cnt_str = get_msgcnt_str($start_msg, $end_msg, $num_msgs);
    //serve per la funzione SelectMessage in mailbox_display.js
    echo '<script language="JavaScript" type="text/javascript">
            var custom_css = "'.$custom_css.'";
	    var msgread = "'.jsspecialchars(_("(Read)")).'";
	    var select_message_onclick = '.$select_message_onclick.';
	</script>';
    //
    if ($msgs[key($msort)]['ID']) {
	echo '<BODY onload="parent.MessageLoad(\''.urlencode($mailbox).'\','.$start_msg.','.$msgs[key($msort)]['ID'].','.$reload_tree_folder_on_action.')">';
    } else {
	echo '<BODY onload="parent.MessageLoad(\''.urlencode($mailbox).'\','.$start_msg.',0,'.$reload_tree_folder_on_action.')">';
    }
    echo '<table border="0" width="100%" cellpadding="0" cellspacing="0">';
	echo '<tr><td>';
	$safe_name = preg_replace("/[^0-9A-Za-z_]/", '_', $mailbox);
	$form_name = "FormMsgs" . $safe_name;
	echo addForm($base_uri.'src/move_messages.php', 'POST', $form_name);
	if (!isset($msg)) { $msg = ''; }
	$moveFields = addHidden('msg', $msg).
		    addHidden('mailbox', $mailbox).
		    addHidden('targetMailbox', '').
		    addHidden('startMessage', $start_msg);
	echo $moveFields;
	echo '    <table width="100%" height="100%" cellpadding="0" cellspacing="0" align="center"'.' border="0">';
	echo '     <tr><td>';

    displayMessageArray($imapConnection, $num_msgs, $start_msg, 
		      $msort, $mailbox, $sort, $color, $show_num,0,0);
	echo '</td></tr></table>';
	if ($num_msgs) {
	    echo '<tr><td>';
	    mail_message_listing_overlook($imapConnection, $mailbox, $sort, $msg_cnt_str, $paginator_str, $start_msg);
	}
    echo '</td></tr></table>';
    //$t = elapsed($start);
    //echo("elapsed time = $t seconds\n");
}

function calc_msort($msgs, $sort) {

    /*
     * 0 = Date (up)
     * 1 = Date (dn)
     * 2 = Name (up)
     * 3 = Name (dn)
     * 4 = Subject (up)
     * 5 = Subject (dn)
     */

    if (($sort == 0) || ($sort == 1)) {
        foreach ($msgs as $item) {
            $msort[] = $item['TIME_STAMP'];
        }
    } elseif (($sort == 2) || ($sort == 3)) {
        foreach ($msgs as $item) {
            $msort[] = $item['FROM-SORT'];
        }
    } elseif (($sort == 4) || ($sort == 5)) {
        foreach ($msgs as $item) {
            $msort[] = $item['SUBJECT-SORT'];
        }
    } else {
        $msort = $msgs;
    }
    if ($sort < 6) {
        if ($sort % 2) {
            asort($msort);
        } else {
            arsort($msort);
        }
    }
    return $msort;
}

function fillMessageArray($imapConnection, $id, $count, $show_num=false) {
    return sqimap_get_small_header_list($imapConnection, $id, $show_num);
}


/* Generic function to convert the msgs array into an HTML table. */
function displayMessageArray($imapConnection, $num_msgs, $start_msg,
                             $msort, $mailbox, $sort, $color,
                             $show_num, $where=0, $what=0) {
    global $imapServerAddress, $use_mailbox_cache, $index_order,
           $indent_array, $thread_sort_messages, $allow_server_sort,
           $server_sort_order, $PHP_SELF,$squirrelmail_plugin_hooks;

    $res = getEndMessage($start_msg, $show_num, $num_msgs);
    $start_msg = $res[0];
    $end_msg   = $res[1];

    $urlMailbox = urlencode($mailbox);

    /* get indent level for subject display */
    if ($thread_sort_messages == 1 && $num_msgs) {
        $indent_array = get_parent_level($imapConnection);
    }

    $real_startMessage = $start_msg;
    if ($sort == 6) {
        if ($end_msg - $start_msg < $show_num - 1) {
            $end_msg = $end_msg - $start_msg + 1;
            $start_msg = 1;
        } else if ($start_msg > $show_num) {
            $end_msg = $show_num;
            $start_msg = 1;
        }
    }
    $endVar = $end_msg + 1;

    /*
     * Loop through and display the info for each message.
     * ($t is used for the checkbox number)
     */
    $t = 0;

    /* messages display */

    if (!$num_msgs) {
	echo '&nbsp;</td></tr><tr><td align="center" colspan="'.count($index_order).'"><b>';
	echo codeHTML(_("THIS FOLDER IS EMPTY"));
	echo '</b>';
    } elseif ($start_msg == $end_msg) {
    /* if there's only one message in the box, handle it differently. */
        if ($sort != 6) {
            $i = $start_msg;
        } else {
            $i = 1;
        }
        reset($msort);
        $k = 0;
        do {
            $key = key($msort);
            next($msort);
            $k++;
        } while (isset ($key) && ($k < $i));
    	    printMessageInfo($imapConnection, $t, true, $key, $mailbox,
                         $real_startMessage, $where, $what);
    } else {
        $i = $start_msg;
        reset($msort);
        $k = 0;
        do {
            $key = key($msort);
            next($msort);
            $k++;
        } while (isset ($key) && ($k < $i));
        $not_last = true;
        do {
            if (!$i || $i == $endVar-1) $not_last = false;
        	printMessageInfo($imapConnection, $t, $not_last, $key, $mailbox,
                                 $real_startMessage, $where, $what);
            $key = key($msort);
            $t++;
            $i++;
            next($msort);
        } while ($i && $i < $endVar);
    }
}

function mail_message_listing_overlook($imapConnection, $mailbox, $sort = -1, $msg_cnt_str, $paginator = ' ', $start_msg = 1) {

    global $color, $auto_expunge, $base_uri, $thread_sort_messages,
           $allow_thread_sort, $allow_server_sort, $server_sort_order,
           $PHP_SELF;

    $php_self = $PHP_SELF;
    /* fix for incorrect $PHP_SELF */
    if (strpos($php_self, 'move_messages.php')) {
        $php_self = str_replace('move_messages.php', 'right_main.php', $php_self);
    }
    $urlMailbox = urlencode($mailbox);

    if (preg_match('/^(.+)\?.+$/',$php_self,$regs)) {
        $source_url = $regs[1];
    } else {
        $source_url = $php_self;
    }

    if (!isset($msg)) {
        $msg = '';
    }
    echo addHidden('overlook_action', '');
    /*
     * This is the beginning of the message list table.
     * It wraps around all messages
     */
    $safe_name = preg_replace("/[^0-9A-Za-z_]/", '_', $mailbox);
    $form_name = "FormMsgs" . $safe_name;
    echo '<table class="titleright" align="center" border="0" width="100%" cellpadding="3"  cellspacing="0">
	    <tr>
		<td align="left">'.$paginator.'</td>
		<td align="right" nowrap=1>'.$msg_cnt_str.'</td>
	    </tr>
	</table>';
    if (!strpos($php_self,'mailbox')) {
        $location = $php_self.'?mailbox=INBOX&startMessage=1';
    } else {
        $location = $php_self;
    }
    echo addHidden('location', $location);

    do_hook('mailbox_form_before');

    /* if using server sort we highjack the
     * the $sort var and use $server_sort_order
     * instead. but here we reset sort for a bit
     * since its easy
     */
    if ($allow_server_sort == TRUE) {
        $sort = $server_sort_order;
    }
}

function printHeader($mailbox, $sort, $color, $showsort=true) {
    global $index_order,$squirrelmail_plugin_hooks, $base_uri, $custom_css;

    echo html_tag( 'tr' ,'' , 'center', '' );
    foreach ($index_order as $item) {
        switch ($item) {
        case 1: /* checkbox */
                $safe_name = preg_replace("/[^0-9A-Za-z_]/", '_', $mailbox);
                echo '<td onClick="parent.CheckAll(parent.right.document.FormMsgs'.$safe_name.')" align="center" width="20"><img title="'._("Toggle All").'" src="'.$base_uri.'images/'.$custom_css.'/checkbox.gif"></td>';
            break;
        case 2: /* from */
            if (handleAsSent($mailbox)) {
                echo html_tag( 'td' ,'' , 'left', '', 'width="25%"' )
                     . '<b>' . codeHTML(_("To")) . '</b>';
            } else {
                echo html_tag( 'td' ,'' , 'left', '', 'width="25%"' )
                     . '<b>' . codeHTML(_("From")) . '</b>';
            }
            if ($showsort) {
                ShowSortButton($sort, $mailbox, 2, 3);
            }
            echo "</td>\n";
            break;
        case 3: /* date */
            echo html_tag( 'td' ,'' , 'left', '', 'width="10%" nowrap' )
                 . '<b>' . codeHTML(_("Date")) . '</b>';
            if ($showsort) {
                ShowSortButton($sort, $mailbox, 0, 1);
            }
            echo "</td>\n";
            break;
        case 4: /* subject */
        	echo html_tag( 'td' ,'' , 'left', '', '' )
                 . '<b>' . codeHTML(_("Subject")) . '</b>';
            if ($showsort) {
                ShowSortButton($sort, $mailbox, 4, 5);
            }
            echo "</td>\n";
            break;
        case 5: /* flags */
                echo '<td align="center" width="20"><img src="'.$base_uri.'images/'.$custom_css.'/msg_new.gif"></td>';
            break;
        case 6: /* size */
            echo html_tag( 'td', '<b>' . codeHTML(_("Size")) . '</b>', 'right', '', 'width="10%" nowrap' );
            break;
        case 7: /* priority */
                echo '<td align="center" width="20"><img src="'.$base_uri.'images/'.$custom_css.'/prio_high.gif"></td>';
            break;
        case 8: /* attach */
                echo '<td align="center" width="20"><img src="'.$base_uri.'images/'.$custom_css.'/attach.gif"></td>';
            break;
        }
    }
    echo "</tr>\n";
}


/*
 * This function shows the sort button. Isn't this a good comment?
 */
function ShowSortButton($sort, $mailbox, $Up, $Down ) {
    global $PHP_SELF,$squirrelmail_plugin_hooks, $base_uri, $custom_css;
    /* Figure out which image we want to use. */
    if ($sort != $Up && $sort != $Down) {
        $img = 'sort_none.png';
        $which = $Up;
    } elseif ($sort == $Up) {
        $img = 'up_pointer.png';
        $which = $Down;
    } else {
        $img = 'down_pointer.png';
        $which = 6;
    }

    if (preg_match('/^(.+)\?.+$/',$PHP_SELF,$regs)) {
        $source_url = $regs[1];
    } else {
        $source_url = $PHP_SELF;
    }
         echo ' <a href="'.$base_uri.'src/title_right.php?newsort=' . $which
          . '&startMessage=1&mailbox=' . urlencode($mailbox)
          . '" onClick="parent.message_id_selected=0; parent.right.location.href=\''.$base_uri.'src/right_main.php?newsort=' .$which. '&startMessage=1&mailbox=' . urlencode($mailbox).'\'"><IMG SRC="'.$base_uri.'images/'.$custom_css.'/' . $img
          . '" BORDER=0 TITLE="'.codeHTML(_("sort")).'"></a>';
}

/*
 * This function computes the "Viewing Messages..." string.
 */
function get_msgcnt_str($start_msg, $end_msg, $num_msgs) {
    /* Compute the $msg_cnt_str. */
    $result = '';
    if ($start_msg < $end_msg) {
        $result = sprintf(_("Viewing Messages: <B>%s</B> to <B>%s</B> (%s total)"),
                          $start_msg, $end_msg, $num_msgs);
    } else if ($start_msg == $end_msg) {
        $result = sprintf(_("Viewing Message: <B>%s</B> (1 total)"), $start_msg);
    } else {
        $result = '<br>';
    }
    /* Return our result string. */
    return ($result);
}

/*
 * Generate a paginator link.
 */
function get_paginator_link($box, $start_msg, $use, $text) {
    global $PHP_SELF,$base_uri;

    $result = "<A HREF=\"".$base_uri."src/right_main.php?use_mailbox_cache=$use"
            . "&startMessage=$start_msg&mailbox=$box\" "
            . "TARGET=\"right\">".codeHTML($text)."</A>";
    return ($result);
}

/*
 * This function computes the paginator string.
 */
function get_paginator_str($box, $start_msg, $end_msg, $num_msgs, $show_num, $sort,$mailbox) {

    global $username, $data_dir, $use_mailbox_cache, $color, $PG_SHOWNUM, $base_uri,
	$allow_thread_sort, $thread_sort_messages, $num_msg_show_all;

    /* Initialize paginator string chunks. */
    $prv_str = '';
    $nxt_str = '';
    $pg_str  = '';
    $all_str = '';
    $tgl_str = '';

    $box = urlencode($box);

    /* Create simple strings that will be creating the paginator. */
    $spc = '&nbsp;';     /* This will be used as a space. */
    $sep = '&nbsp;|&nbsp;';          /* This will be used as a seperator. */

    /* Get some paginator preference values. */
    $pg_sel = getPref($data_dir, $username, 'page_selector', SMPREF_ON);

    /* Make sure that our start message number is not too big. */
    $start_msg = min($start_msg, $num_msgs);

    /* Decide whether or not we will use the mailbox cache. */
    /* Not sure why $use_mailbox_cache is even passed in.   */
    if ($sort == 6) {
        $use = 0;
    } else {
        $use = 1;
    }

    /* Compute the starting message of the previous and next page group. */
    $next_grp = $start_msg + $show_num;
    $prev_grp = $start_msg - $show_num;

    /* Compute the basic previous and next strings. */
    if (($next_grp <= $num_msgs) && ($prev_grp >= 0)) {
	$prv_str = "<A onclick=\"parent.message_id_selected=0;\" HREF=\"".$base_uri."src/right_main.php?use_mailbox_cache=$use"
	            . "&startMessage=$prev_grp&mailbox=$box\" "
		    . "TARGET=\"right\">".codeHTML(_("Previous"))."</A>";
	$nxt_str = "<A onclick=\"parent.message_id_selected=0;\" HREF=\"".$base_uri."src/right_main.php?use_mailbox_cache=$use"
	            . "&startMessage=$next_grp&mailbox=$box\" "
		    . "TARGET=\"right\">".codeHTML(_("Next"))."</A>";
    } else if (($next_grp > $num_msgs) && ($prev_grp >= 0)) {
	$prv_str = "<A onclick=\"parent.message_id_selected=0;\" HREF=\"".$base_uri."src/right_main.php?use_mailbox_cache=$use"
	            . "&startMessage=$prev_grp&mailbox=$box\" "
		    . "TARGET=\"right\">".codeHTML(_("Previous"))."</A>";
        $nxt_str = "<SPAN CLASS=\"disabled\">".codeHTML(_("Next"))."</SPAN>\n";
    } else if (($next_grp <= $num_msgs) && ($prev_grp < 0)) {
        $prv_str = "<SPAN CLASS=\"disabled\">".codeHTML(_("Previous")) . '</SPAN>';
	$nxt_str = "<A onclick=\"parent.message_id_selected=0;\" HREF=\"".$base_uri."src/right_main.php?use_mailbox_cache=$use"
	            . "&startMessage=$next_grp&mailbox=$box\" "
		    . "TARGET=\"right\">".codeHTML(_("Next"))."</A>";
    }

    /* Page selector block. Following code computes page links. */
    if ($pg_sel && ($num_msgs > $show_num)) {
	/* caso di non show all */
    } else if ($PG_SHOWNUM == 999999) {
        $pg_str = "<A onclick=\"parent.message_id_selected=0;\" HREF=\"".$base_uri."src/right_main.php?PG_SHOWALL=0"
                . "&use_mailbox_cache=$use&startMessage=1&mailbox=$box\" "
                . "TARGET=\"right\">" .codeHTML(_("Paginate")) . '</A>' . $spc;
    }
    if (($prv_str != '') || ($nxt_str != '')) {
	if ($num_msgs > $num_msg_show_all) {
    	    $all_str = "<A HREF=\"javascript:if(confirm('"._('Warning!\nViewing all messages may take a lot of time and overload your server.\nContinue anyway?')."')) { location.href='".$base_uri."src/right_main.php?PG_SHOWALL=1" 
                 . "&use_mailbox_cache=$use&startMessage=1&mailbox=$box'; }\" "
                 . "TARGET=\"right\">" . codeHTML(_("Show All")) . '</A>';
	} else {
    	    $all_str = "<A HREF='".$base_uri."src/right_main.php?PG_SHOWALL=1" 
                 . "&use_mailbox_cache=$use&startMessage=1&mailbox=$box' "
                 . "TARGET=\"right\">" . codeHTML(_("Show All")) . '</A>';
	}
    }

    /**
     * Hairy code... But let's leave it like it is since I am not certain
     * a different approach would be any easier to read. ;)
     */
    $result = '';
    if ($pg_str) {
	$result .= $pg_str; 
    } else {
	if ($prv_str) { $result .= $prv_str . '<span class="linkseparator">'. $sep . '</span>'; }
	if ($nxt_str) { $result .= $nxt_str . '<span class="linkseparator">'. $sep . '</span>'; }
	if ($all_str) { $result .= $all_str; }
    }

    /* draws thread sorting links */
    if ($allow_thread_sort == TRUE && $num_msgs > 1) {
        if ($thread_sort_messages == 1 ) {
            $set_thread = 2;
            $thread_name = codeHTML(_("Unthread View"));
        } elseif ($thread_sort_messages == 0) {
            $set_thread = 1;
            $thread_name = codeHTML(_("Thread View"));
        }
	$source_url= $base_uri.'src/right_main.php?sort='."$sort" . '&start_messages=1&set_thread=' . "$set_thread". '&mailbox=' . urlencode($mailbox);
	$url_title = $base_uri."src/title_right.php?";
	if ($PG_SHOWNUM == 999999) { $url_title.="PG_SHOWALL=1"; $newjs=""; }
	else { $url_title.="PG_SHOWALL=0"; $newjs="parent.message_id_selected=0;"; }	
	$url_title .= '&sort=0&startMessage='.$start_msg.'&mailbox='.urlencode($mailbox).'&set_thread=' . $set_thread;
	if ($result) { $result .= '<span align="center" class="linkseparator" width="1%">'.$sep . '</span>'; }
	$result .= '<a onclick="'.$newjs.'parent.TimeoutTitleRight(\''.$source_url.'\',\''.$url_title.'\');" href=\'#\'>' . $thread_name. '</a>'; 
    }
    if ($result) { $result .= "$spc"; }
    /* Return our final magical paginator string. */
    return ($result);
}

function processSubject($subject, $threadlevel = 0, $trim_at) {
    global $languages, $squirrelmail_language;
    /* Shouldn't ever happen -- caught too many times in the IMAP functions */
    if ($subject == '') {
        return _("(no subject)");
    }

    /* if this is threaded, subtract two chars per indentlevel */
    if($threadlevel > 0 && $threadlevel <= 10) {
        $trim_at -= (2*$threadlevel);
    }

    if (strlen($subject) <= $trim_at) {
        return $subject;
    }

    $ent_strlen = $orig_len = strlen($subject);
    $trim_val = $trim_at - 5;
    $ent_offset = 0;
    /*
     * see if this is entities-encoded string
     * If so, Iterate through the whole string, find out
     * the real number of characters, and if more
     * than 55, substr with an updated trim value. 
     */
    $step = $ent_loc = 0;
    while ( $ent_loc < $trim_val && (($ent_loc = strpos($subject, '&', $ent_offset)) !== false) &&
            (($ent_loc_end = strpos($subject, ';', $ent_loc+3)) !== false) ) {
        $trim_val += ($ent_loc_end-$ent_loc);
        $ent_offset  = $ent_loc_end+1;
        ++$step;
    }
    
    if (($trim_val > 50) && (strlen($subject) > ($trim_val))&& (strpos($subject,';',$trim_val) < ($trim_val +6))) {
        $i = strpos($subject,';',$trim_val);
        if ($i) {
            $trim_val = strpos($subject,';',$trim_val);
        }
    }
    if ($ent_strlen <= $trim_at){
        return $subject;
    }

    if (isset($languages[$squirrelmail_language]['XTRA_CODE']) &&
        function_exists($languages[$squirrelmail_language]['XTRA_CODE'])) {
        return $languages[$squirrelmail_language]['XTRA_CODE']('strimwidth', $subject, $trim_val);
    }

    // only print '...' when we're actually dropping part of the subject
    if(strlen($subject) <= $trim_val) {
        return $subject;
    } else {
        return substr($subject, 0, $trim_val) . '...';
    }
}

function processSender($field) {
    global $languages, $squirrelmail_language, $max_char_sender_m;
    /* Shouldn't ever happen -- caught too many times in the IMAP functions */
    if ($field == '') {
        return _("(sender unknown)");
    }

    $trim_at = $max_char_sender_m;

    if (strlen($field) <= $trim_at) {
        return $field;
    } else {
	return substr($field, 0, $trim_at) . '...';  
    }
}

function getMbxList($imapConnection) {
    global $lastTargetMailbox;
    echo  '         <small>&nbsp;<tt>';
    $new_option =  sqimap_mailbox_option_list($imapConnection, array(strtolower($lastTargetMailbox)) ); 
    echo addSelect('targetMailbox', $new_option, $lastTargetMailbox, TRUE);
    echo '</TT>&nbsp;';
}

function getButton($type, $name, $value) {
    return '<INPUT TYPE="'.$type.'" NAME="'.$name.'" VALUE="'.$value . '">';
}

function getSmallStringCell($string, $align) {
    return html_tag('td',
                    '<small>' . codeHTML($string) . ':&nbsp; </small>',
                    $align,
                    '',
                    'nowrap' );
}

function getEndMessage($start_msg, $show_num, $num_msgs) {
    if ($start_msg + ($show_num - 1) < $num_msgs){
        $end_msg = $start_msg + ($show_num - 1);
    } else {
        $end_msg = $num_msgs;
    }

    if ($end_msg < $start_msg) {
        $start_msg = $start_msg - $show_num;
        if ($start_msg < 1) {
            $start_msg = 1;
        }
    }
    return (array($start_msg,$end_msg));
}

function handleAsSent($mailbox) {
    global $handleAsSent_result;
 
    /* First check if this is the sent or draft folder. */
    $handleAsSent_result = isSentMailbox($mailbox) || isDraftMailbox($mailbox);

    /* Then check the result of the handleAsSent hook. */
    do_hook('check_handleAsSent_result', $mailbox);

    /* And return the result. */
    return $handleAsSent_result;
}

?>
