<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * page_header.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Prints the page header (duh)
 *
 * $Id: page_header.php,v 1.4 2004/05/26 09:26:15 marco Exp $
 */

if (!defined('SM_PATH')) { define('SM_PATH','../'); }

require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/imap_mailbox.php');
require_once(SM_PATH . 'functions/global.php');

/* Always set up the language before calling these functions */
function displayHtmlHeader( $title = 'OverLook', $xtra = '', $do_hook = TRUE ) {
    if (!$title) { $title = 'OverLook'; }
    if ( !sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION) ) {
        global $base_uri;
    }
    global $theme_css, $custom_css, $pageheader_sent, $squirrelmail_language;

    echo html_tag( 'html' ,'' , '', '', '' ) . "\n<head>\n";

	if ($custom_css) {
    	    echo '<link rel="stylesheet" type="text/css" href="' .
    	        $base_uri . 'css/'.$custom_css.'.css" />'."\n";
	} else {
    	    echo '<link rel="stylesheet" type="text/css" href="' .
    	        $base_uri . 'css/'.$theme_css.'.css" />'."\n";
	}

    if (isset($squirrelmail_language) && $squirrelmail_language == 'ja_JP') {
	// why it is added here. header ('Content-Type:..) is used in i18n.php
        echo "<!-- \xfd\xfe -->\n";
        echo '<meta http-equiv="Content-type" content="text/html; charset=euc-jp">' . "\n";
    }

    echo "\n<meta name=\"Pragma\" content=\"no-cache\" />\n";
    echo "\n<title>$title</title>$xtra\n";

    echo "\n</head>\n\n";

    /* this is used to check elsewhere whether we should call this function */
    $pageheader_sent = TRUE;
}

?>