<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/*
 * tnef.php
 *
 *  Bernd Wiegmann <bernd@wib-software.de>
 *  Graham Norbury <gnorbury@bondcar.com>
 *  (c) 2002 (GNU GPL - see ../../COPYING)
 *
 */

/*
 *   $Header: /var/cvs-base/overlook/plugins/outlook/attachment_tnef/tnef.php,v 1.3 2004/06/02 07:40:39 marco Exp $
 *
 *   $Log: tnef.php,v $
 *   Revision 1.3  2004/06/02 07:40:39  marco
 *   Sistemazione rubrica e gruppi su database: manca il test
 *
 *   Revision 1.2  2004/06/01 13:39:51  marco
 *   Implementazione vera e test di plugin attachment_tnef
 *
 *   Revision 1.1.1.1  2004/02/02 14:00:13  marco
 *   Versione base di modfica a SquirrelMail
 *
 *   Revision 1.1  2004/01/27 15:40:05  marco
 *   Inglobato in outlook plugin attachment_tnef: da testare. Sistemazione varia di interfaccia: altezza barra navigazione printer_friendly, larghezza immagini in barra navigazione di printer_friendly e compose
 *
 *   Revision 1.1  2004/01/23 16:36:18  marco
 *   Aggiunta di plugins. Aggiunta in opzioni personali possibilita' di link a sqmadmin.
 *
 *   Revision 1.22  2003/10/10 12:50:52  bernd
 *   Don't try to hide the warning attachment. This prevented some attachments
 *   to be shown at all.
 *
 *   Revision 1.21  2003/10/08 15:34:26  bernd
 *   Fixed some bugs.
 *
 *   Revision 1.20  2003/10/08 15:29:23  bernd
 *   Removed old warning message about RTF attachments.
 *
 *   Revision 1.19  2003/10/08 15:19:36  bernd
 *   Display also RTF attachments and don't show useless attachments like to small
 *   RTF files or warning messages.
 *
 *   Revision 1.18  2003/09/11 11:36:45  bernd
 *   Preparations for beta release.
 *
 *   Revision 1.2  2003/07/12 21:54:10  bernd
 *   Removed broken code that caused warnings and changed some messages which are now translatable.
 *
 *   Revision 1.1.1.1  2003/07/02 09:12:46  bernd
 *   initial import into CVS
 *
 */
    
/* 
 *  Displays table of contents and handles attachment download for ms-tnef files
 *
 */

   if (!defined('SM_PATH')) { define('SM_PATH', '../../'); }

   include_once(SM_PATH . 'include/validate.php');

   include_once(SM_PATH . 'functions/date.php');
   include_once(SM_PATH . 'functions/page_header.php');
   include_once(SM_PATH . 'functions/mime.php');
   include_once(SM_PATH . 'functions/global.php');

   include_once(SM_PATH . 'plugins/attachment_tnef/tnef_attachment.php');


   sqgetGlobalVar('tnef_debug', $tnef_debug, SQ_SESSION);
   sqgetGlobalVar('tnef_download', $tnef_download, SQ_SESSION);
   sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION);

   sqgetGlobalVar('absolute_dl', $absolute_dl);
   sqgetGlobalVar('file_id', $file_id);
   sqgetGlobalVar('key', $key, SQ_COOKIE);
   sqgetGlobalVar('mailbox', $mailbox);
   sqgetGlobalVar('passed_ent_id', $passed_ent_id);
   sqgetGlobalVar('passed_id', $passed_id);
   sqgetGlobalVar('startMessage', $startMessage);
   sqgetGlobalVar('username', $username);
   global $custom_css;

   $tnef_debug = 0; // change this to 1 to enable debugging output

   $tnef_download = (!isset($file_id)) ? 0 : 1;       // only display page if not downloading
   $tnef_debug = ((!$tnef_download) && $tnef_debug);  // debugging disabled when downloading

   sqsession_register($tnef_download, 'tnef_download');
   sqsession_register($tnef_debug, 'tnef_debug');

   // extract the tnef attachment and decode it
   $imapConnection = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
   sqimap_mailbox_select($imapConnection, $mailbox);
   $message = sqimap_get_message($imapConnection, $passed_id, $mailbox);
   $entity_tnef = getEntity($message,$passed_ent_id);

   $tnef = mime_fetch_body ($imapConnection, $passed_id, $passed_ent_id); 
   $tnef = decodeBody($tnef, $entity_tnef->header->encoding);

   $attachment = &new TnefAttachment($tnef_debug);
   $result = $attachment->decodeTnef($tnef);
   $tnef_files = &$attachment->getFilesNested();

// only display page if not downloading
if (!$tnef_download) {
      $mailinfo = &$attachment->getMailinfo();
      $subject = $mailinfo->getSubject();
      $topic = $mailinfo->getTopic();
      $from_mail = $mailinfo->getFrom();
      $from_name = $mailinfo->getFromName();
      $obj = &$mailinfo->getDateSent();

      $show_it = 0;
      $id = 0;

    displayHtmlHeader( '', '' );
    echo '<body onload="self.focus();">';
    echo '<table height="100%" width="100%" cellpadding="2" cellspacing="1" align="center"'.' border="0">
	    <tr height="1%">
		<td class="navevidenced" align="left" valign="middle" width="80%" valign="top">
		    ' . codeHTML(_("Download attachments")) . ':
		</td>
		<td width="20%" class="nav" onClick="self.close();" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" align="center">
		    '.codeHTML(_("Close")).'
		</td>	
	    </tr>';
        foreach ($tnef_files as $file) {
	    if (get_class($file) != "tnefvcard") {
		$dl_href = 'tnef.php?' . $HTTP_SERVER_VARS['QUERY_STRING'] . "&file_id=$id";
		echo '<TR><TD width="80%" class="nav" onclick=\'location.href="'.$dl_href.'&absolute_dl=1"\' onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">'
                        .codeHTML($file->getName()).
			'</TD><TD width="20%" class="navevidenced" onclick=\'window.open("'.$dl_href.'","_blanck","width=400,height=400,scrollbars=yes");\' onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'navevidenced\'" align="center"><IMG BORDER=0 WIDTH="30" SRC="'.$base_uri.'images/'.$custom_css.'/view.gif"></TD></TR>';
	    // IMHO the following html is very difficult to interpret...
	    // For consistency with the way other attachments are displayed
	    // this is more or less a straight copy from mime.php
	    } else if (get_class($file) == "tnefvcard") {
		$dl_href = 'tnef.php?' . $HTTP_SERVER_VARS['QUERY_STRING'] . "&file_id=$id";
		$disp=_("Name").": ";
		$value = $file->getGivenName();
	        if ($value) { $disp .= $value; }
		$value = $file->getMiddleName();
		if ($value) { $disp .= ' ' . $value; }
		$value = $file->getSurname();
		if ($value) { $disp .= ' ' . $value; }
		$disp .= "\n";
		if ($file->getCompany()) { $disp .= _("Company").": ".$file->getCompany()."\n"; }
		$telefones = &$file->getTelefones();
		ksort($telefones);
		foreach ($telefones as $telkey => $telvalue) {
		    $disp .= _($telkey).": ".$telvalue."\n";
		}
		$emails = &$file->getEmails();
		ksort($emails);
		foreach ($emails as $emailkey => $emailvalue) {
		    if ($emailvalue[EMAIL_DISPLAY]) {
			$disp .= _($emailvalue[EMAIL_DISPLAY]).": ";
		    } else {
			$disp .= _($emailkey).": ";
		    }
		    $disp .= $emailvalue[EMAIL_EMAIL]."\n";
		}
		$homepages = &$file->getHomepages();
		foreach ($homepages as $hpkey => $hpvalue) {
		    $disp .= _($hpkey).": ".$hpvalue."\n";
		}
		echo '<TR><TD width="80%" class="nav" onclick=\'location.href="'.$dl_href.'&absolute_dl=1"\' onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">'
                	.codeHTML($disp).
			'</TD><TD align="center" width="20%" class="navevidenced" onclick=\'location.href="'.$dl_href.'"\' onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'navevidenced\'"><IMG BORDER=0 WIDTH="30" SRC="'.$base_uri.'images/'.$custom_css.'/view.gif"></TD></TR>';
	    }
	    $id++;
        }
    echo '</table></body></html>';
//download the requested attachment
} else {
      set_time_limit(0); // disable 30 second timer in case download takes a while

      DumpHeaders($tnef_files[$file_id]->getType(),
                  $tnef_files[$file_id]->getName(),
                  $tnef_files[$file_id]->getSize(),
                  $absolute_dl);

      echo($tnef_files[$file_id]->getContent());
}
?>