<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * keyview.php
 * ----------------
 * GPG Key view page
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @author Joshua Vermette
 * @author Aaron Van Meerten
 * @author Brian Peterson
 *
 * $Id: keyview.php,v 1.28 2004/01/03 22:04:23 ke Exp $
 */

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in genkey.php, exiting abnormally";
}

require_once(SM_PATH.'functions/prefs.php');
require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');
require_once(SM_PATH.'plugins/gpg/gpg_functions.php');
require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');

sqgetGlobalVar('base_uri', $base_uri,     SQ_SESSION);

sqgetGlobalVar('ring',$ringName);
//hack to reset keyring to 'all' if new keys were being viewed.
if (!$ringName) { $ringName = 'all'; }
//Get the key fingerprint.
sqgetGlobalVar('fpr',$fpr);

//Make the passthrough string for keyring_main.
sqgetGlobalVar('pos',$pos, SQ_GET);
sqgetGlobalVar('sort',$sort, SQ_GET);
sqgetGlobalVar('desc',$desc, SQ_GET);
sqgetGlobalVar('srch',$srch, SQ_GET);

//Fetch the keys.
$ring = new gpg_keyring();
$err = $ring->fetchKeys($fpr, $ringName);
if ($err['errors']) gpg_bail($err['errors']);

//Get the key.
$key = $ring->getKey($fpr);

//Check to see if this key is part of a keypair on the ring
if ($ringName == 'all') {
    $err = $ring->fetchKeys($fpr,'secret');
    if ($ring->numKeys() > 0) {
        $secretKey = true;
    } else {
        $secretKey = false;
    }
}
//Map of useful field names to readable names.
$fieldNames = array('email_addr' => _("Owner Email"),
            'date' => _("Generation Date"),
            'exp' => _("Expiration Date"),
            'len' => _("Key Length"),
            'id' => _("ID"),
            'alg' => _("Algorithm"));

if ($ringName == "secret") {
    //Secret ring.
    //Signing key?
    if (getPref($data_dir, $username, 'use_signing_key_id') &&
        getPref($data_dir, $username, 'signing_key_id') == $key['id']) {
        $signing = true;
    }

} else {
    //Regular ring.
    //Trusted key?
    if (getPref($data_dir, $username, 'use_trusted_key_id') &&
        getPref($data_dir, $username, 'trusted_key_id') == $key['id']) {
        $trusted = true;
    }
   //Put public key in new window?
    if (getPref($data_dir, $username, 'compose_new_win')) {
	$compose_new_win = true;
	//fetch ascii-armored public key text
	$text = $ring->getExportText($fpr, $ringName);
    }
}
$requirepassphrase = $GLOBALS['GPG_SYSTEM_OPTIONS']['requirepassphraseonkeydelete'];

function showkeyButtonRow() {
    global $color;
    global $secretKey, $base_uri;
    global $ringName;
    global $compose_new_win;
    global $text;
    echo '<td width="33%" nowrap=1>';
    if ($ringName == "secret") {
	echo addSubmit(_("Save"), 'keysav','','','','',true,true).'&nbsp;';
    }
    echo addSubmit(_("Cancel"), 'can','','','','',true,true).'&nbsp;';
    echo '</td>';
    echo '<td width="33%" align="center" nowrap=1>';
	if ($ringName == "secret") {
	    echo '&nbsp;';
	} else {
	    $url = $base_uri.'src/compose.php?bodymsg='.urlencode($text);
	    echo addButton(_("Email Key"), 'em','','new_win_overlook("compose","'.$url.'",700,600,1,50,50);','','',true,true);
	    echo '&nbsp;'.addSubmit(_("View Key"), 'disp','','','','',true,true);
	}
    echo '</td><td align="right" width="33%" nowrap=1>';
    if ($ringName == "all") {
	//check to see if this is part of a keypair
	if ($secretKey) {
//	    echo addButton(_("Delete Keypair"), 'dhelp','','return delpConf();','','',true,true);
	} else {
	    echo addButton(_("Delete"), 'del','','return delConf();','','',true,true);
	}
    } elseif ($ringName == "secret") {
	echo addSubmit(_("Delete"), 'del','','return delsConf()','','',true,true).'&nbsp;';
	echo addSubmit(_("Delete Keypair"), 'delp','','return delpConf()','','',true,true);
    }
    echo "</td>";
}

$confirmstr=_("Remove this key from your keyring?  This action cannot be undone!");

echo <<<TILLEND
<script language=javascript>
<!--
function delConf()
{
    if (confirm("$confirmstr"))
    {
        document.keyview.deletekey.value="true";
    document.keyview.submit();
        return true;
    }
    else {
        return false;
    }
}

function delpConf()
{
    if (confirm("$confirmstr")) {
TILLEND;
if ($requirepassphrase=='true') {
        echo "window.open('".$base_uri."plugins/gpg/gpg_pop_init.php?MOD=passpop&psaction=deletepair','Confirm_Delete','status=yes,width=300,height=200,resizable=yes');\n}\nreturn false;\n";
} else {
	echo "}\ndocument.keyview.deletepair.value=\"true\";\n return true;\n";
}
echo <<<TILLEND
}

function delsConf()
{
    if (confirm("$confirmstr")) {
TILLEND;
if ($requirepassphrase=='true') {
        echo "window.open('".$base_uri."plugins/gpg/gpg_pop_init.php?MOD=passpop&psaction=delete','Confirm_Delete','status=yes,width=300,height=200,resizable=yes');\n}\nreturn false;\n";
} else {
	echo "}\ndocument.keyview.deletekey.value=\"true\";\n return true;\n";
}
echo <<<TILLEND
}
//-->
</script>
TILLEND;

require_once(SM_PATH.'plugins/gpg/modules/gpg_module_header.php');

echo '<tr>
        <td align="left" width="100%" valign="top">
            <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

// ===============================================================
$section_title = _("GPG Options - Display Key");
gpg_page_title( $section_title );
// ===============================================================

if (! $fpr) { gpg_bail("keyview no fpr"); }
if (! $key) gpg_bail("keyview bad key ('$ringName', '$fpr')");

sqgetGlobalVar('err', $err_get, SQ_GET);

if ($err_get) {
    echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo '<font color=red>' . codeHTML(_("Error: ") . $err_get) . '</font><br>';
    echo '</td></tr>';
}

echo '<tr valign="top"><td width="100%" height="1%" class="nav">';
    echo '<table width="95%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0" align="center">';
        echo '<tr valign="top">';
            echo addForm($base_uri.'plugins/gpg/modules/keyring_main.php', 'POST', 'keyview');
            echo addHidden('id', $key['id']);
            echo addHidden('fpr', $fpr);
            echo addHidden('pos', $pos);
            echo addHidden('sort', $sort);
            echo addHidden('desc', $desc);
            echo addHidden('srch', $srch);
            echo addHidden('ring', $ringName);
            echo addHidden('passphrase', '');
            echo addHidden('deletekey', 'false');
            echo addHidden('deletepair', 'false');
	echo '</tr>';
        echo '<tr><td width="100%" height="1%" class="nav" align="center" colspan=3>';
	    if ($ringName == "secret") echo codeHTML(_("Secret Key: "));
	    echo codeHTML($key['email_name']);
	echo '</td></tr>';
        echo '<tr><td width="100%" height="1%" class="nav" align="center" colspan=3>';
        //bordo esterno
        echo  '<table cellpadding="1" cellspacing="0" border="0" width="100%">';
            echo '<tr><td bgcolor="#000000" width="100%">';
            //tabella interna
            echo '<table cellpadding="3" cellspacing="1" bgcolor="#FFFFFF" border="0" width="100%">';
                echo '<tr class="optionlink"><td colspan=3>';
		    if ($ringName == "secret") {
			if ($signing) { $checked = true; } else { $checked = false; }
			echo addCheckBox('signing', $checked, 1);
			echo codeHTML(_("This is my SIGNING key"));
			echo '&nbsp;&nbsp;';
			echo '<font size="-1">';
			echo  gpg_add_help_link ( 'what_signing.php' )
        		    . codeHTML(_("What's this?"))
        		    . '</a>';
			echo '</font>';
		    } else {
			//***** Parte disabilitata perche' non completa nella versione GPG corrente ****
			//if ($trusted) { $checked = true; } else { $checked = false; }
			//echo addCheckBox('trust', $checked, 1);
			//echo codeHTML(_("This is my TRUSTED key"));
			//echo '&nbsp;&nbsp;';
			//echo '<font size="-1">';
			//echo  gpg_add_help_link ( 'what_trusted.php' )
        		//. codeHTML(_("What's this?"))
        		//. '</a>';
			//echo '</font>';
			echo "&nbsp;\n";
		    }
		echo '</td></tr>';
		foreach($fieldNames as $field => $name) {
		    if ($key[$field]) {
			echo "<tr>\n<td width=1%><b>".codeHTML($name.':').'</b></td>';
			if ($field == "email_addr") {
			    $url=$base_uri.'src/compose.php?send_to=' .urlencode($key[$field]); 
    			    echo '<td><a class="gpg" href=';
				echo "'$url'";
    			    echo  "'>" . codeHTML($key[$field]) . "</a></td>";
			} else {
    			    echo "<td>". codeHTML($key[$field]) . "</td>";
			}
			echo '</tr>';
		    }
		}
	    echo '</table>';
	    echo '</td></tr>';
	echo '</table>';
    echo '</td></tr>'; 
    if ($key["sub"]) {
	foreach($key["sub"] as $sId => $sKey) {
    	    echo '<tr><td width="100%" height="1%" class="nav" align="center" colspan=3>';
	    echo "<font size=+1><b><u>" . codeHTML(_("Subkey") . " '" . $sKey['id']). "'</u></b></font>\n";
	    echo '<table border="0" cellpadding="2" cellspacing="0">';
    	    foreach($fieldNames as $field => $name) {
    		if ($field == "id") { continue; }
		if ($sKey[$field]) {
        	    echo "<tr><td width=5%><b>".codeHTML($name.':').'</b></td>';
        	    echo "<td width=95%>".codeHTML($sKey[$field])."</td>\n</tr>";
    		}
    	    }
    	    echo "\n\t</table>\n";
        }
    }
    echo addForm($base_uri.'plugins/gpg/modules/keyring_main.php', 'POST');
    echo '<tr valign="top" class="optionlink">';
	showkeyButtonrow();
    echo '</tr>';
    echo '</form>';
    echo '</table></td></tr><tr>
        <td align="left" width="100%" class="nav">
                    &nbsp;
                </td>
            </tr>';
    echo '</table>';

require_once (SM_PATH.'plugins/gpg/modules/gpg_module_footer.php');

/**
 * For Emacs weenies:
 * Local variables:
 * mode: php
 * c-basic-offset: 4
 * End:
 */

/**
 * $Log
 * Revision 1.12  2003/10/06 22:49:33  ke
 * -Added keyring to default to all if none specified
 *
 * Revision 1.11  2003/10/04 00:56:42  ke
 * -added check for error array in return from keyring functions
 *
 * Revision 1.10  2003/08/14 02:37:33  vermette
 * minor fix, and add deletion for secret keys
 *
 * Revision 1.9  2003/08/02 01:54:53  vermette
 * added signing key functionality to consolidated interface.  Removed old signing key page from keymgmt.mod, but left file in cvs because it's used in getstart.mod.  Added viewing of secret keyring.
 *
 * Revision 1.8  2003/07/24 06:46:12  vermette
 * folded trusted key UI into consolidated interface.  This replaces the current UI, but I haven't removed it from the menus yet.
 *
 * Revision 1.7  2003/07/20 06:44:47  vermette
 * added key emailing.  added click-thru from key view to compose to key owner.  Speed enhancements on keyview.
 *
 * Revision 1.6  2003/07/17 07:33:07  vermette
 * time-saving modifications to hack around gpg's lack of ability to restrict output size.  Added system keyring into consolidated interface.
 *
 * Revision 1.5  2003/07/11 07:43:12  vermette
 * added search to keyring_main
 *
 * Revision 1.4  2003/07/11 06:54:03  vermette
 * keyring work.  Added chunking, first/prev/next/last, sorting, and ascending v. descending sorted view.  Also modified key table to give more info.
 *
 * Revision 1.3  2003/07/08 19:10:29  vermette
 * tightening error messaging.  UI work on gpg_keyring class.  Proper display of empty keyring
 *
 * Revision 1.2  2003/07/08 18:01:51  vermette
 * rename publicring.php to keyring_main.php
 *
 * Revision 1.1  2003/07/08 17:56:32  vermette
 * new key detail page
 *
 *
 */

?>
