<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * addressbook.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Manage personal address book.
 *
 * $Id: addressbook.php,v 1.10 2004/06/02 10:10:39 marco Exp $
 */
/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/addressbook_nav.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

/* lets get the global vars we may need */
sqgetGlobalVar('key',       $key,           SQ_COOKIE);

sqgetGlobalVar('username',  $username,      SQ_SESSION);
sqgetGlobalVar('onetimepad',$onetimepad,    SQ_SESSION);
sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);

//operazioni su i contatti
sqgetGlobalVar('addaddr',   $addaddr,   SQ_POST);
sqgetGlobalVar('takeaddr',   $takeaddr,   SQ_POST);
sqgetGlobalVar('editaddr',  $editaddr,  SQ_POST);
sqgetGlobalVar('deladdr',   $deladdr,   SQ_POST);
sqgetGlobalVar('searchaddr',   $searchaddr,   SQ_POST);

// parametri
sqgetGlobalVar('sel',       $sel,       SQ_POST);
sqgetGlobalVar('backend',   $backend,   SQ_POST);
sqgetGlobalVar('newbackend',   $newbackend,   SQ_POST);
sqgetGlobalVar('start_contact', $start_contact); 

if (!$searchaddr) { sqgetGlobalVar('searchaddr',   $searchaddr,   SQ_GET); }

global $addrbook_table_user, $address_book_count, $show_fieldarrayabook, $fieldarrayabook, 
$custom_css, $global_abook_master, $addrbook_dsn;

/* Sort array by the key "name" */
function alistcmpoverlook($a,$b) {
    return (strtolower($a['Nominativo']) > strtolower($b['Nominativo'])) ? 1 : -1;
}

function GetVisualPhone($phone) {
    $phoneinvert = strrev($phone);
    $phonepartial = preg_replace('/(\d\d\d)/','$1.',$phoneinvert);
    $phone = strrev($phonepartial);
    $phone = preg_replace('/^\./','',$phone);
    return $phone;
}

$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
}

$errstr="";

/* Handle user's actions */
if((sqgetGlobalVar('REQUEST_METHOD', $req_method, SQ_SERVER) && $req_method == 'POST') || $searchaddr) {
    /**************************************************
     * Add new address                                *
     **************************************************/
    if ($addaddr) {
        $newdata = array();
	foreach ($fieldarrayabook as $namehidden => $v) {
	    if ($namehidden == "idrub") { continue; }
	    sqgetGlobalVar($namehidden, $newdata[$namehidden],   SQ_POST);
	}
	if ($newbackend == 2) {
    	    $r = $abook->add($newdata, $newbackend);
	} else {
    	    $r = $abook->add($newdata, $abook->localbackend);
	}
        /* Handle error messages */
        if (!$r) {
            /* Remove backend name from error string */
            $errstr = $abook->error;
            $errstr = ereg_replace('^\[.*\] *', '', $errstr);
        }
	displayHtmlHeader (_("Addressbook"));

	echo '<body onload="self.focus();">';
	echo '<script language="javascript">window.resizeTo(400,200);</script>'."\n";  
	echo '<table valign="top" height="100%" cellpadding=0 cellspacing=0 border=0 width="100%">'."\n";
	if ($errstr) {
	    echo '<tr height="70%"><td valign="middle" align="center" class="error">';
		echo codeHTML($errstr);
	} else {
	    echo '<tr height="70%"><td valign="middle" align="center" class="success">';
		echo codeHTML(_("Addressbook updated succesfully."));
	}
    	echo '</td></tr>';
	echo '<tr height="30%">
		<td align="center" class="nav" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onClick="parent.opener.document.location.reload(); window.close()">
		    '.codeHTML(_("Close")).'
		</td>
	     </tr>
	    </table></body></html>';
	exit();          
    /**************************************************
     * Add new address da take                        *
     **************************************************/
    } else if (isset($takeaddr) && $takeaddr) {
        $newdata = array();
	foreach ($fieldarrayabook as $namehidden => $v) {
	    if ($namehidden == "idrub") { continue; }
	    sqgetGlobalVar($namehidden, $newdata[$namehidden],   SQ_POST);
	}
	if ($newbackend == 2) {
    	    $r = $abook->add($newdata, $newbackend);
	} else {
    	    $r = $abook->add($newdata, $abook->localbackend);
	}

        /* Handle error messages */
        if (!$r) {
            /* Remove backend name from error string */
            $errstr = $abook->error;
            $errstr = ereg_replace('^\[.*\] *', '', $errstr);
        }

	displayHtmlHeader (_("Addressbook"));

	echo '<body onload="self.focus();">';
	echo '<script language="javascript">window.resizeTo(400,200);</script>'."\n";  
	echo '<table valign="top" height="100%" cellpadding=0 cellspacing=0 border=0 width="100%">'."\n";
	if ($errstr) {
	    echo '<tr height="70%"><td valign="middle" align="center" class="error">';
		echo codeHTML($errstr);
	} else {
	    echo '<tr height="70%"><td valign="middle" align="center" class="success">';
		echo codeHTML(_("Addressbook updated succesfully."));
	}
    	echo '</td></tr>';
	echo '<tr height="30%">
		<td align="center" class="nav" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onClick="window.close()">
		    '.codeHTML(_("Close")).'
		</td>
	     </tr>
	    </table></body></html>';
	exit();          
    /************************************************
    * Delete address(es)                           *
    ************************************************/
    } else if ($deladdr && $sel) {
        /* The selected addresses are identidied by "backend:nickname". *
        * Sort the list and process one backend at the time            */
        $delfailed = false;
        list($sbackend, $snick) = explode(':', $sel);
        $r = $abook->remove($snick, $sbackend);
        if (!$r) {
	    $errstr = $abook->error;
	    $errstr = ereg_replace('^\[.*\] *', '', $errstr);	
        }
	// contatto privato: cerco su gruppi privato dell'utente
	if ($sbackend == 1) {
	    $r = $gabook->remove_contacts($snick,1);
    	    if (!$r) {
		$errstr .= $gabook->error;
		$errstr = ereg_replace('^\[.*\] *', '', $errstr);	
    	    }
	// contatto pubblico: cerco su gruppi privati (di tutti gli utenti) e gruppi pubblici
	} else {
    	    $users = array();
    	    preg_match('/@(.+)$/',$username,$match);
    	    if (isset($match[1]) && $match[1]) { $domain = $match[1]; } else { $domain=""; }
	    // lettura da database
	    if (isset($addrbook_dsn) && !empty($addrbook_dsn)) {
		// rimuovo contatto pubblico da gruppi pubblici (1 come terzo parametro)
		$r = $gabook->remove_contacts($snick,2,1);
                include_once(SM_PATH . 'functions/abook_get_user.php');
                $uab = new abook_get_user($username);
                $users = $uab->get_list_username($domain);
	    // lettura da files
            } else {
        	if ($dir = @opendir($data_dir)) {
            	    while (($file = readdir($dir)) !== false) {
            		if (preg_match('/^(.+)@'.$domain.'\.group$/',$file,$match)) {
                    	    array_push($users,$match[1]."@".$domain);
                	}
            	    }
            	    closedir($dir);
        	}
	    }
            foreach ($users as $user) {
		$ubook = addressbook_init(true, true, $user);
		$uabook = $ubook[0];
		$ugabook = $ubook[1];
		// rimuovo contatto pubblico (1 come terzo parametro)
		$r = $ugabook->remove_contacts($snick,$ugabook->localbackend,1);
    		if (!$r) {
		    $errstr .= $ugabook->error;
		    $errstr = ereg_replace('^\[.*\] *', '', $errstr);	
    		}
	    }
	}
    /***********************************************
    * Update/modify address                       *
    ***********************************************/
    } else if ($editaddr && $sel) {
        $newdata = array();
	foreach ($fieldarrayabook as $namehidden => $v) {
	    if ($namehidden == "idrub") { continue; }
	    sqgetGlobalVar($namehidden, $newdata[$namehidden],   SQ_POST);
	}
	list($sbackend, $snick) = explode(':', $sel);
	if ($newbackend && $newbackend == 2 && $sbackend == 1) {
    	    $r = $abook->remove($snick, $sbackend);
    	    $r = $abook->add($newdata, $newbackend);
	} else if ($sbackend == 2 && !$newbackend) {
    	    $r = $abook->remove($snick, $sbackend);
    	    $r = $abook->add($newdata, 1);
	} else {
	    $newdata['idrub']=$snick;
    	    $r = $abook->modify($snick, $newdata, $sbackend);
	}
        /* Handle error messages */
	$errstr = $abook->error;
	$errstr = ereg_replace('^\[.*\] *', '', $errstr);

	displayHtmlHeader (_("Addressbook"));

	echo '<body onload="self.focus();">';
	echo '<script language="javascript">window.resizeTo(400,200);</script>'."\n";  
	echo '<table valign="top" height="100%" cellpadding=0 cellspacing=0 border=0 width="100%">'."\n";
	if ($errstr) {
	    echo '<tr height="70%"><td valign="middle" align="center" class="error">';
		echo codeHTML($errstr);
	} else {
	    echo '<tr height="70%"><td valign="middle" align="center" class="success">';
		echo codeHTML(_("Addressbook updated succesfully."));
	}
    	echo '</td></tr>';
	echo '<tr height="30%">
		<td align="center" class="nav" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onClick="parent.opener.document.location.reload(); window.close()">
		    '.codeHTML(_("Close")).'
		</td>
	     </tr>
	    </table></body></html>';
	exit();          
    }
    /***********************************************
    * Search address                       	   *
    ***********************************************/
    if ($searchaddr) {
	sqgetGlobalVar('searchbackend',   $backend,   SQ_POST);   
	sqgetGlobalVar('searchstring',   $query,   SQ_POST);   
	sqgetGlobalVar('searchfield',   $field,   SQ_POST);   
	if (!$backend) {
	    sqgetGlobalVar('searchbackend',   $backend,   SQ_GET);   
	}
	if (!$query) {
	    sqgetGlobalVar('searchstring',   $query,   SQ_GET);   
	}
	if (!$field) {
	    sqgetGlobalVar('searchfield',   $field,   SQ_GET);   
	}
        if($backend == -1) {
            $alist = $abook->search($query, $field);
        } else {
            $alist = $abook->search($query, $field, $backend);
        }
        if (!is_array($alist)) {
	    $errstr = _("Your search failed with the following error(s)") .
                                 ":\n" . $abook->error . "\n";
        }
    } else {
	/* Get and sort address list */
	$alist = $abook->list_addr();
    }
} else {
    /* Get and sort address list */
    $alist = $abook->list_addr();
}


displayHtmlHeader (_("Addressbook"),'');

displayJavascriptAddressBook();

echo '<body onload="self.focus();">';
/* =================================================================== *
 * The following is only executed on a GET request, or on a POST when  *
 * a user is added, or when "delete" or "modify" was successful.       *
 * =================================================================== */

    if(!is_array($alist)) {
        plain_error_message(codeHTML($abook->error), $color);
        exit;
    }

    usort($alist,'alistcmpoverlook');    

    $prevbackend = -1;
    $headerprinted = false;

    echo '<div id="div_new" style="position:absolute;z-index:16;visibility:hidden;top:0px;left:0px;">
	    <table align="left" valign="top" class="border" cellpadding=2 cellspacing=0 border=0>
		<tr><td onClick="CreateAdd(1)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Contact")).'</td></tr>
		<tr><td onClick="CreateAdd(2)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Private Group")).'</td></tr>';
    if (in_array($username,$global_abook_master)) {	
	echo '<tr><td onClick="CreateAdd(3)" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav">'.codeHTML(_("Public Group")).'</td></tr>';
    }
    echo '</table></div>';

    echo '<table valign="top" cellpadding=0 cellspacing=0 border=0 width="100%" height="100%">'."\n";
	echo '<tr><td height="1%" valign="top">';
	    displayNavigationAddressBook();
        echo '</td></tr>';
    if ($errstr) {
	echo '<tr><td height="1%" valign="middle" align="center" class="error">';
	    echo codeHTML($errstr);
        echo '</td></tr>';
    }
    if ($searchaddr) {
	    if ($backend == -1) {
		$stringbackend = _("All address books");
	    } else {
		// cerco su tutti i backends
		$ret = $abook->get_backend_list('');
                while (list($undef,$v) = each($ret)) {
		    if ($v->bnum == $backend) {
			$stringbackend=$v->sname;
			break;
		    }
                }
	    }
	echo '<tr><td height="1%" valign="middle" align="center" class="success">';
	    echo codeHTML(_("Addressbook:").' '.$stringbackend."\n"._("Expression:").' '.$query."\n"._("Where:").' '._($fieldarrayabook[$field]['label']));
        echo '</td></tr>';
    }
    echo addForm($base_uri.'src/addressbook.php', 'POST', 'f');
    echo addHidden('sel', '');
    echo addHidden('deladdr', '0');
    echo addHidden('editaddr', '0');
    echo addHidden('addaddr', '0');
    echo addHidden('searchaddr', $searchaddr);
    echo addHidden('searchstring', $query);
    echo addHidden('searchfield', $field);
    echo addHidden('searchbackend', $backend);
    echo addHidden('newbackend', '');
    echo addHidden('start_contact', $start_contact);

    foreach ($fieldarrayabook as $namehidden => $v) {
	if ($namehidden == "idrub" || $namehidden == "SendPredefined" || $namehidden == "syncr") { continue; }
	echo addHidden($namehidden, '');
    }
    if (!count($alist) || count($alist) == 0) {
	echo '<tr><td width="100%" align="center" valign="middle" class="nav">';  
	    if ($searchaddr) {
		echo codeHTML(_("No contacts founds."));
	    } else {
	    	echo codeHTML(_("The addressbook is empty."));
	    }
	    echo '</td></tr>';
    	    echo '</form>';
	    echo '</table></td></tr>';
    } else {
	echo '<tr><td height="1%" valign="top">';
	    echo '<table height="1%" class="border" width="100%" align="center" valign="top" cellspacing=2 cellpadding=3 border=0 valign="top">' . "\n";
		echo '<tr width="100%" height="1%">
			<td class="addressbookth" align="center" width="20">&nbsp;</td>
			<td class="addressbookth" align="center" width="20">&nbsp;</td>';
		foreach ($show_fieldarrayabook as $key) {
		    echo '<td class="addressbookth" align="left">'.codeHTML(_($fieldarrayabook[$key]["label"])).'</td>';
		}
		echo '</tr>';
		$n_contacts=count($alist);  
		$id=0; 
		$modify_global=0;
		if (in_array($username,$global_abook_master)) { $modify_global=1; }
		while(list($undef,$row) = each($alist)) {
		    if ($id >= $start_contact && $id < ($start_contact+$address_book_count)) { 
			echo '<tr height="1%">';
        		    if ($row['source'] == _("Global address book")) {
				if ($modify_global) {
				    echo '<td onclick="ModifySelected(\''.$row['backend'].':'.$row['idrub'].'\',0);" class="abookglobal" onmouseover="this.className=\'abookglobalclicked\'" onmouseout="this.className=\'abookglobal\'" align="center" width="20">';
					echo '<img alt="'._("Edit Global").'" src="'.$base_uri.'images/'.$custom_css.'/edit_small.gif" border=0>';
					echo '</td>';
					echo '<td onclick="DeleteSelected(\''.$row['backend'].':'.$row['idrub'].'\',0);" class="abookglobal" onmouseover="this.className=\'abookglobalclicked\'" onmouseout="this.className=\'abookglobal\'" align="center" width="20">';
                                    	    echo '<img alt="'._("Trash Global").'" src="'.$base_uri.'images/'.$custom_css.'/delete_small.gif" border=0>';
                                	echo '</td>';
				} else {
            			    echo '<td class="abookglobal" align="center" width="20">';
					echo '<img alt="'._("Public").'" src="'.$base_uri.'images/'.$custom_css.'/post_it.gif" border=0>';
					echo '</td>';
					echo '<td class="abookglobal" align="center" width="20">';
				    	    echo '&nbsp;';
                                	echo '</td>';
				}
        		    } else {
				echo '<td onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="ModifySelected(\''.$row['backend'].':'.$row['idrub'].'\',0);" class="nav" align="center" width="20">';
					echo '<img alt="'._("Edit").'" src="'.$base_uri.'images/'.$custom_css.'/edit_small.gif" border=0>';
				    echo '</td>';
				    echo '<td onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" onclick="DeleteSelected(\''.$row['backend'].':'.$row['idrub'].'\',0);" class="nav" align="center" width="20">';
                                        echo '<img alt="'._("Trash").'" src="'.$base_uri.'images/'.$custom_css.'/delete_small.gif" border=0>';
                                    echo '</td>';
			    }
			    foreach ($show_fieldarrayabook as $key) {
				if ($fieldarrayabook[$key]['functions']) { 
				    eval('$value='.$fieldarrayabook[$key]['functions'].'("'.$row[$key].'");'); 
				} else { $value = $row[$key]; } 	    
				if ($value) {
				    echo '<td class="nav" align="'.$fieldarrayabook[$key]['align'].'">'.codeHTML($value).'</td>';
				} else {
				    echo '<td class="nav" align="left">&nbsp;</td>';
				}
			    }
			echo '</tr>'."\n";
		    }
		    $id++;
    		}
		echo '</form>';
		echo '</table></td></tr>';
	    if ($searchaddr) {
		$urlsearch = '&searchaddr='.$searchaddr.'&searchstring='.urlencode($query).'&searchfield='.$field.'&searchbackend='.$backend;
	    } else {
		$urlsearch = "";
	    }
	    echo '<tr><td valign="top" align="center" class="nav" width="100%">';
		if ($start_contact >= $address_book_count) {
    		    echo '<a href="'.$base_uri.'src/addressbook.php?start_contact='.($start_contact-$address_book_count).$urlsearch.'">
            		    <img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer.gif">
            		</a>&nbsp;&nbsp;';
		} else {
    		    echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer_disabled.gif">&nbsp;&nbsp;';
		}
		if ($start_contact+$address_book_count < $n_contacts) {
    		    echo '<a href="'.$base_uri.'src/addressbook.php?start_contact='.($start_contact+$address_book_count).$urlsearch.'">
            		    <img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer.gif">
            		</a>';
		} else {
    		    echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer_disabled.gif">';
		}
	    echo '</td></tr>';
        echo '</table>';
    }
?>

</BODY></HTML>
