<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../');    
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

displayHtmlHeader( '', '' );

global $address_book_list_count, $custom_css;

sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );  

sqgetGlobalVar('start_contact', $start_contact, SQ_GET);   


$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
}

/* Get and sort address list */
$alist = $abook->list_addr(-1,1);
if(!is_array($alist)) {
    plain_error_message(codeHTML($abook->error), $color);
    exit;
}

/* Sort array by the key "name" */
function alistcmpoverlook($a,$b) {
    return (strtolower($a['Nominativo']) > strtolower($b['Nominativo'])) ? 1 : -1;
}

usort($alist,'alistcmpoverlook');

set_colors_js_IEbug("A:link","A.selectedadress");

echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/list_address.js"></script>'."\n";

if (count($alist) > 0) {    
    echo '<table width="100%" heigth="100%" border=0 cellpadding=0 cellspacing=0 valign="middle" align="left">';
    $n_contacts=count($alist);
    echo '<tr><td align="center">';
    if ($start_contact >= $address_book_list_count) {
	echo '<a href="'.$base_uri.'src/list_address.php?start_contact='.($start_contact-$address_book_list_count).'">
		<img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer.gif">
	      </a>&nbsp;&nbsp;';
    } else {
	echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer_disabled.gif">&nbsp;&nbsp;';
    }
    if ($start_contact+$address_book_list_count < $n_contacts) {
	echo '<a href="'.$base_uri.'src/list_address.php?start_contact='.($start_contact+$address_book_list_count).'">
		<img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer.gif">
	      </a>';
    } else {
	echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer_disabled.gif">';
    }
    echo '</td></tr>';
    $id=0;
    while(list($undef,$row) = each($alist)) {   
	if ($id >= $start_contact && $id < ($start_contact+$address_book_list_count)) {
	    echo '<tr><td>';
	    $send_to=$row['Email'];
	    if ($row['source'] == _("Global address book")) {
		echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/post_it.gif">&nbsp;';
	    } else {
		echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/smile.gif">&nbsp;';
	    }    
	    echo '<a href="#" id="adress'.$id.'" onclick="SelectedAdress('.$id.'); 
	    parent.new_win_overlook(\'compose\',\''.$base_uri.'src/compose.php?send_to='.urlencode($send_to).'\',700,600,1,0,0)">';
	    echo codeHTML($row['Nominativo']);
	    echo '</a>';
	    echo '</td></tr>';
	}
	$id++;
    }
    echo '<tr><td align="center">';
    if ($start_contact >= $address_book_list_count) {
	echo '<a href="'.$base_uri.'src/list_address.php?start_contact='.($start_contact-$address_book_list_count).'">
		<img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer.gif">
	      </a>&nbsp;&nbsp;';
    } else {
	echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/left_pointer_disabled.gif">&nbsp;&nbsp;';
    }
    if ($start_contact+$address_book_list_count < $n_contacts) {
	echo '<a href="'.$base_uri.'src/list_address.php?start_contact='.($start_contact+$address_book_list_count).'">
		<img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer.gif">
	      </a>';
    } else {
	echo '<img border=0 src="'.$base_uri.'images/'.$custom_css.'/right_pointer_disabled.gif">';
    }
    echo '</td></tr>';
    echo '</table>';
}
?>