<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * login.php -- simple login screen
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This a simple login screen. Some housekeeping is done to clean
 * cookies and find language.
 *
 * $Id: login.php,v 1.6 2004/05/17 14:24:45 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/i18n.php');
require_once(SM_PATH . 'functions/plugin.php');
require_once(SM_PATH . 'functions/constants.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/forms.php');

if (isset($_COOKIE['overlookautologin']) && $_COOKIE['overlookautologin']) {
    header('Location: redirect.php');
    exit;
}

/*
 * $squirrelmail_language is set by a cookie when the user selects
 * language and logs out
 */
set_up_language($squirrelmail_language, TRUE, TRUE);

/**
 * Find out the base URI to set cookies.
 */
if (!function_exists('sqm_baseuri')){
    require_once(SM_PATH . 'functions/display_messages.php');
}

$base_uri = sqm_baseuri();

/*
 * In case the last session was not terminated properly, make sure
 * we get a new one.
 */

sqsession_destroy();
 
header('Pragma: no-cache');

do_hook('login_cookie');

/* Output the javascript onload function. */

$header = '<script language="JavaScript" type="text/javascript">
    var smpref_js_on = "'.SMPREF_JS_ON.'";
    var flag_loginname = '.(isset($loginname) ? 2 : 1).';
</script>'."\n";

displayHtmlHeader( "$org_name - " . _("Login"), $header, FALSE );

echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/login.js"></script>';

global $squirrelmail_plugin_hooks, $demo_version, $demo_user, $demo_password, $link_download;

echo '<body class="bodylogin" onload="overlook_loginpage_onload();">' ."\n";

echo addForm($base_uri.'src/redirect.php', 'POST','formlogin')."\n";
$username_form_name = 'login_username';
$password_form_name = 'secretkey';
do_hook('login_top');

$loginname_value = (sqGetGlobalVar('loginname', $loginname) ? htmlspecialchars($loginname) : '');

/* If they don't have a logo, don't bother.. */
if (isset($org_logo) && $org_logo) {
    /* Display width and height like good little people */
    $width_and_height = '';
    if (isset($org_logo_width) && is_numeric($org_logo_width) &&
     $org_logo_width>0) {
        $width_and_height = " width=\"$org_logo_width\"";
    }
    if (isset($org_logo_height) && is_numeric($org_logo_height) &&
     $org_logo_height>0) {
        $width_and_height .= " height=\"$org_logo_height\"";
    }
}

    global $enable_set_domain, $_SERVER;
    echo '<br /><br /><br /><br />'."\n";
    echo '<table align="center" valign="middle" height="50%" class="border" border="0" cellspacing="0" cellpadding="0" width="50%">'."\n";
	if (isset($hide_sm_attributions) && $hide_sm_attributions) {
	    $rowspan='rowspan=2';
	} else {
	    $rowspan='';
	}
	if (isset($org_logo)) {
	    echo '<tr '.$rowspan.'>
		    <td onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" class="nav" onclick="window.open(\'../credits/credits.html\',\'credits\',\'width=550,height=520,scrollbars=yes,resizable=yes\');" align="center" colspan=2>
			<img src="'.$org_logo.'" alt="'._("Click here from credits").'" border=0 '.$width_and_height.'>
		    </td>
		</tr>'."\n";
	}
	echo '<tr>
		    <td class="nav" align="center" colspan=2>
			<a href="http://www.openit.it">OverLook by Open IT</a>
		    </td>
		</tr>'."\n";
	echo '<tr>
		    <td class="optionlink" align="center" colspan=2>
			'.codeHTML(sprintf(_("%s Login"), $org_name)).'
		    </td>
		</tr>'."\n";
	if ($enable_set_domain == 1) {
	    $login_default = '@'.$_SERVER['SERVER_NAME'];
	} else if ($enable_set_domain == 2) {
	    $login_default = $_SERVER['SERVER_NAME'];
	    $login_default = preg_replace("/^[^\.]+\./", '', $login_default);
	    $login_default = '@'.$login_default; 	    
	} else {
	    $login_default='';
	}
	if ($demo_version) {
	    echo '<tr>
		    <td class="nav" align="right" width="37%">'.codeHTML(_("Name")).':</td>
		    <td class="nav">';
		    echo addHidden($username_form_name, $demo_user);
		    echo addInput('a',$login_default);
		    echo '</td>';
	    echo '</tr>'."\n";
	    echo '<tr>
		    <td class="nav" align="right" width="37%">
			'.codeHTML(_("Password")).':
		    </td>
		    <td class="nav">';
			echo addPwField('b' , '');
			echo addHidden('js_autodetect_results', SMPREF_JS_OFF);
			echo addHidden('just_logged_in', '1');
			echo addHidden($password_form_name, $demo_password);
		    echo '</td>
		</tr>'."\n";
	} else {
	    echo '<tr>
		    <td class="nav" align="right" width="37%">
			'.codeHTML(_("Name")).':
		    </td>
		    <td class="nav">';
			echo addInput($username_form_name,$login_default);
		    echo '</td>
		</tr>'."\n";
	    echo '<tr>
		    <td class="nav" align="right" width="37%">
			'.codeHTML(_("Password")).':
		    </td>
		    <td class="nav">';
			echo addPwField($password_form_name , '');
			echo addHidden('js_autodetect_results', SMPREF_JS_OFF);
			echo addHidden('just_logged_in', '1');
		    echo '</td>
		</tr>'."\n";
	}
	echo '<tr>
		    <td class="nav" align="center" colspan=2>';
			echo codeHTML(_("Remember login")).':&nbsp;'.addCheckBox('autologin', FALSE, 1);	
		    echo '</td>
		</tr>'."\n";
	if ($demo_version && $link_download) {
	    echo '<tr>
		    <td class="nav" align="center" colspan=2>
			<A href="'.$link_download.'">'.codeHTML(_("Overlook download")).'</A>
		    </td>
		</tr>'."\n";
	}
	echo '<tr><td class="optionlink" align="center" colspan=2>';
	    echo addSubmit(_("Login"),'','','','formlogin');
	echo '</td></tr>'."\n";
    echo '</table>';
do_hook('login_form');
echo '</form>' . "\n";
 
do_hook('login_bottom');
echo '<br /><br />'."\n";
echo '<center>
	<A target="_blank" href="http://www.openit.it">
	    <img src="'.$base_uri.'images/openit.gif" border=0>
	</A>
	&nbsp;&nbsp;
	<A href="http://www.hgblu.com" target="_blank">
	    <img src="'.$base_uri.'images/hgblu.gif" border=0>
	</A>
    </center>';

echo "</body>\n".
     "</html>\n";
?>
