<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * options_identities.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Display Identities Options
 *
 * $Id: options_identities.php,v 1.2 2004/02/25 15:02:08 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

sqgetGlobalVar('base_uri', $base_uri,     SQ_SESSION);

/* POST data var names are dynamic because 
   of the possible multiple idents so lets get
   them all
*/
if (!empty($_POST)) { extract($_POST); }
/* got 'em all */

    if (isset($return)) {
       SaveUpdateFunction();
       header('Location: options_personal.php');
       exit();
    }
    $Info = do_hook('options_identities_process', 0);
    if ($Info[1]) {
        SaveUpdateFunction();
    }
    
    if (CheckAndDoDefault()) { SaveUpdateFunction(); }

    if ((isset($update) && $update==1) || CheckForDelete()) { SaveUpdateFunction(); }

    $identities_list= array();    
    LoadInfo($full_name, $email_address, $reply_to, $signature, '');
    $identities_list["g"]["full_name"]= $full_name;
    $identities_list["g"]["email_address"]= $email_address;
    $identities_list["g"]["reply_to"]= $reply_to;
    $identities_list["g"]["signature"]= $signature;
    $hiddens .= addHidden('form_for_', '1');
    $hiddens .= addHidden('full_name', $full_name);
    $hiddens .= addHidden('email_address', $email_address);
    $hiddens .= addHidden('reply_to', $reply_to);
    $hiddens .= addHidden('signature', $signature);
    $hiddens .= addHidden('make_default_', '0');
    $hiddens .= addHidden('delete_', '0');
    $num = 1;
    while (LoadInfo($full_name, $email_address, $reply_to, $signature, $num)) {
	$identities_list[$num]["full_name"]= $full_name;
	$identities_list[$num]["email_address"]= $email_address;
	$identities_list[$num]["reply_to"]= $reply_to;
	$identities_list[$num]["signature"]= $signature;
	$hiddens .= addHidden('form_for_'.$num, '1');
	$hiddens .= addHidden('full_name'.$num, $full_name);
	$hiddens .= addHidden('email_address'.$num, $email_address);
	$hiddens .= addHidden('reply_to'.$num, $reply_to);
	$hiddens .= addHidden('signature'.$num, $signature);
	$hiddens .= addHidden('make_default_'.$num, '0');
	$hiddens .= addHidden('delete_'.$num, '0');
        $num++;
    }
    $hiddens .= addHidden('form_for_'.$num, '1');
    $hiddens .= addHidden('full_name'.$num, '');
    $hiddens .= addHidden('email_address'.$num, '');
    $hiddens .= addHidden('reply_to'.$num, '');
    $hiddens .= addHidden('signature'.$num, '');
    $hiddens .= addHidden('make_default_'.$num, '0');
    $hiddens .= addHidden('delete_'.$num, '0');

    displayHtmlHeader(_("Options - Identities"), ''); 
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/options_identities.js"></script>';
    echo '<body onload="ChangeIdentity();self.focus();">';
    echo addForm($base_uri.'src/options_identities.php', 'POST', 'f');
    $hiddens .= addHidden('update', '0');
    echo $hiddens;
    echo '<table border=0 valign="top" class="border" align="left" width="100%" height="100%" cellpadding=0 cellspacing=0>
	    <tr>
		<td class="optionlabel" width="100%" align="left" colspan=2 valign="middle" height="1%"> 
		    '.codeHTML(_("Select an identity:")).'
		</td>
	    </tr>	
	    <tr>
		<td class="nav" width="70%" align="center" valign="top" height="1%">';
		    $new_option = array();
		    $new_option[$num] = array( 'value' => '<'._("New identity").'>' );
		    foreach ($identities_list as $ide => $v) {
			if ($ide == "g") {
			    $new_option[$ide] = array('class' => 'optiondefault', 'value' => $v["full_name"].' <'.$v["email_address"].'>');
			} else {
			    $new_option[$ide] = array('value' => $v["full_name"].' <'.$v["email_address"].'>');
			}
		    }
		    echo addSelect('identity', $new_option, $num, TRUE, 'onChange="ChangeIdentity()" style="width:100%" size=10');
    echo '	</td>
		<td class="nav" valign="top" align="center" height="1%">';
		echo addButton(_("Save"), '', 'style="width:100%"','SetSave();','f','',0,1);
		echo addButton(_("Default"), 'defaultbutton', 'style="width:100%"','SetDefault();','f','',0,1);
		echo addButton(_("Delete"), 'deletebutton', 'style="width:100%"','SetDelete();','f','',0,1);
		echo addButton(_("Close"), 'deletebutton', 'style="width:100%"','parent.opener.document.location.reload(); self.close();','','',1,1);
		echo '</td>
	    </tr>';
    echo '<tr>
		<td class="optionlabel" id="labelidentity" width="100%" align="left" colspan=2 valign="middle" height="1%"> 
		    '.codeHTML(_("Insert a new identity:")).'
		</td>
	    </tr>';	
    echo '<tr>
	    <td colspan=2 width="100%" valign="top">
		<table border=0 align="left" width="100%" height="100%" cellpadding=0 cellspacing=2 valign="top" class="border">
			<tr>
			    <td width="30%" class="nav" valign="middle">
				'.codeHTML(_("Full Name")).':
			    </td>
			    <td class="nav" valign="middle">';
				echo addInput('full_name_new', $full_name, '', '','style="width:100%"');
			    echo '</td>
			</tr>
			<tr>
			    <td width="30%" class="nav" valign="middle">
				'.codeHTML(_("Email Address")).':
			    </td>
			    <td class="nav" valign="middle">';
				echo addInput('email_address_new', $email_address, '', '' ,'style="width:100%"');
			    echo '</td>
			</tr>
			<tr>
			    <td width="30%" class="nav" valign="middle">
				'.codeHTML(_("Reply To")).':
			    </td>
			    <td class="nav" valign="middle">';
				echo addInput('reply_to_new', $reply_to, '', '','style="width:100%"');
			    echo '</td>
			<tr>
			</tr>
			    <td width="30%" valign="top" class="nav">
				'.codeHTML(_("Signature")).':
			    </td>
			    <td class="nav" valign="top">';
				echo addTextArea('signature_new', $signature, 5, '','style="width:100%"');
			    echo '</td>
			</tr>
		    </table>
		</td>
	    </tr>
	</table>';
    echo '</body></html>';

    function SaveUpdateFunction() {
        global $username, $data_dir, $full_name, $email_address, $reply_to, $signature;

        $i = 1;
        $fakeI = 1;
        $name = 'form_for_' . $i;
        global $$name;
        while (isset($$name))
        {
            $name = 'delete_' . $i;
            global $$name;
            if ($$name==1) {
                $fakeI --;
            } else {
                do_hook('options_identities_renumber', $i, $fakeI);
                $filled = 0;

                $name = 'full_name' . $i;
                global $$name;
            if ($$name != '')
                $filled ++;
                setPref($data_dir, $username, 'full_name' . $fakeI, $$name);

                $name = 'email_address' . $i;
                global $$name;
            if ($$name != '')
                $filled ++;
                setPref($data_dir, $username, 'email_address' . $fakeI, $$name);

                $name = 'reply_to' . $i;
                global $$name;
            if ($$name != '')
                $filled ++;
                setPref($data_dir, $username, 'reply_to' . $fakeI, $$name);

                $name = 'signature' . $i;
                global $$name;
            if ($$name != '')
                $filled ++;
                setSig($data_dir, $username, $fakeI, $$name);

            if ($filled == 0)
                $fakeI --;
            }

            $fakeI ++;
            $i ++;
            $name = 'form_for_' . $i;
            global $$name;
        }

        setPref($data_dir, $username, 'identities', $fakeI);

        while ($fakeI != $i)
        {
            removePref($data_dir, $username, 'full_name' . $fakeI);
            removePref($data_dir, $username, 'email_address' . $fakeI);
            removePref($data_dir, $username, 'reply_to' . $fakeI);
            setSig($data_dir, $username, $fakeI, "");
            $fakeI ++;
        }

        setPref($data_dir, $username, 'full_name', $full_name);
        setPref($data_dir, $username, 'email_address', $email_address);
        setPref($data_dir, $username, 'reply_to', $reply_to);
        setSig($data_dir, $username, "g", $signature);
        
    }

    function CheckAndDoDefault() {
        global $username, $data_dir, $full_name, $email_address, $reply_to, $signature;

        $i = 1;
        $name = 'form_for_' . $i;
        global $$name;
        while (isset($$name))
        {
            $name = 'make_default_' . $i;
            global $$name;
            if ($$name==1) {
                do_hook('options_identities_renumber', $i, 'default');
                global $full_name, $email_address, $reply_to, $signature;

                $name = 'full_name' . $i;
                global $$name;
                $temp = $full_name;
                $full_name = $$name;
                $$name = $temp;

                $name = 'email_address' . $i;
                global $$name;
                $temp = $email_address;
                $email_address = $$name;
                $$name = $temp;

                $name = 'reply_to' . $i;
                global $$name;
                $temp = $reply_to;
                $reply_to = $$name;
                $$name = $temp;

                $name = 'signature' . $i;
                global $$name;
                $temp = $signature;
                $signature = $$name;
                $$name = $temp;


                return true;
            }

            $i ++;
            $name = 'form_for_' . $i;
            global $$name;
        }
        return FALSE;
    }

    function CheckForDelete() {
        global $username, $data_dir, $full_name, $email_address, $reply_to, $signature;

        $i = 1;
        $name = 'form_for_' . $i;
        global $$name;
        while (isset($$name))
        {
            $name = 'delete_' . $i;
            global $$name;
            if ($$name==1) {
                return true;
            }

            $i ++;
            $name = 'form_for_' . $i;
            global $$name;
        }
        return false;
    }

    function LoadInfo(&$n, &$e, &$r, &$s, $post) {
        global $username, $data_dir;

        $n = getPref($data_dir, $username, 'full_name' . $post);
        $e = getPref($data_dir, $username, 'email_address' . $post);
        $r = getPref($data_dir, $username, 'reply_to' . $post);
        if ($post == '')
           $post = 'g';
        $s = getSig($data_dir,$username,$post);

        if ($n != '' || $e != '' || $r != '' || $s != '')
            return true;
    }
?>
