<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * webmail.php -- Displays the main frameset
 *
 * Copyright (c) 1999-2003 The SquirrelMail development team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file generates the main frameset. The files that are
 * shown can be given as parameters. If the user is not logged in
 * this file will verify username and password.
 *
 * $Id: webmail.php,v 1.5 2004/06/01 09:40:37 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/prefs.php');
require_once(SM_PATH . 'functions/imap.php');
require_once(SM_PATH . 'functions/plugin.php');
require_once(SM_PATH . 'functions/i18n.php');
require_once(SM_PATH . 'functions/auth.php');
require_once(SM_PATH . 'functions/global.php');

if (!function_exists('sqm_baseuri')){
    require_once(SM_PATH . 'functions/display_messages.php');
}
$base_uri = sqm_baseuri();

sqsession_is_active();

sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter, SQ_SESSION);
sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);

sqgetGlobalVar('right_frame', $right_frame, SQ_GET);

if ( isset($_SESSION['session_expired_post']) ) {
    sqsession_unregister('session_expired_post');
}

is_logged_in();

do_hook('webmail_top');

/**
 * We'll need this to later have a noframes version
 *
 * Check if the user has a language preference, but no cookie.
 * Send him a cookie with his language preference, if there is
 * such discrepancy.
 */
$my_language = getPref($data_dir, $username, 'language');
if ($my_language != $squirrelmail_language) {
    setcookie('overlook_language', $my_language, time()+2592000, $base_uri);
}

$view_contacts_main_page = getPref($data_dir, $username, 'view_contacts_main_page');

set_up_language(getPref($data_dir, $username, 'language'));

    //controllo impostazioni personali obbligatorie dell'utente
    $email_address = getPref($data_dir, $username, 'email_address');
    $full_name     = getPref($data_dir, $username, 'full_name');
    if( trim($email_address) == '' || trim($full_name) == '' ) {
	header('Location: '.$base_uri.'src/options.php?askinfo=1');   	
	exit;
    }

echo "<html><head>\n" .
     "<title>$org_title</title>\n".
     "</head>";

$left_size = getPref($data_dir, $username, 'left_size');
$location_of_bar = getPref($data_dir, $username, 'location_of_bar');

if (isset($languages[$squirrelmail_language]['DIR']) &&
    strtolower($languages[$squirrelmail_language]['DIR']) == 'rtl') {
    $temp_location_of_bar = 'right';
} else {
    $temp_location_of_bar = 'left';
}

if ($location_of_bar == '') {
    $location_of_bar = $temp_location_of_bar;
}
$temp_location_of_bar = '';

if ($left_size == "") {
    if (isset($default_left_size)) {
         $left_size = $default_left_size;
    } else {
        $left_size = 200;
    }
}

/*
 * There are three ways to call webmail.php
 * 1.  webmail.php
 *      - This just loads the default entry screen.
 * 2.  webmail.php?right_frame=right_main.php&sort=X&startMessage=X&mailbox=XXXX
 *      - This loads the frames starting at the given values.
 * 3.  webmail.php?right_frame=folders.php
 *      - Loads the frames with the Folder options in the right frame.
 *
 * This was done to create a pure HTML way of refreshing the folder list since
 * we would like to use as little Javascript as possible.
 */
if (!isset($right_frame)) {
    $right_frame = '';
} 
if ($right_frame == 'right_main.php') {
    $urlMailbox = urlencode($mailbox);
    $right_frame_url = "right_main.php?mailbox=$urlMailbox&sort=$sort&startMessage=$startMessage";
} elseif ($right_frame == 'options.php') {
    $right_frame_url = 'options.php';
} elseif ($right_frame == 'folders.php') {
    $right_frame_url = 'folders.php';
} else if ($right_frame == '') {
    $right_frame_url = 'right_main.php';
} else {
    $right_frame_url =  $right_frame;
}

    global $icon_folder, $reload_tree_folder_on_action;
    global $compose_width, $compose_height;

    sqgetGlobalVar('HTTP_USER_AGENT', $HTTP_USER_AGENT, SQ_SERVER);

    //START JAVASCRIPT
    echo '<script language="JavaScript" type="text/javascript">
	    var moveframesup = 0;
	    var win_compose;
            var base_uri = "'.$base_uri.'";
        </script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/parent.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/new_window.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/header.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/mailbox_display.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/left_main.js"></script>'."\n";
    if ($use_banner && count($banners)) {
        echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/banner.js"></script>'."\n";
    }
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/folder_name.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/title_right.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/read_body.js"></script>'."\n";

    //END JAVASCRIPT
    $urlMailbox = urlencode($mailbox);  
    if (preg_match('/MSIE/', $HTTP_USER_AGENT)) {
	$framesetborder=0;
	$frameborder=0;
    } else {
	$framesetborder=1;
	$frameborder=0;
    }
    if ($icon_folder) {
	echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" rows=\"50,25,*\" id=\"fs1\" name=\"fs1\">\n";
    } else {
	echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" rows=\"20,25,*\" id=\"fs1\" name=\"fs1\">\n";
    }
	echo "<frame src=\"".$base_uri."src/navigation.php\" scrolling=\"no\" name=\"header\" marginheight=0 marginwidth=0 frameborder=\"$frameborder\" noresize=\"1\"/>\n";
	echo "<frame src=\"".$base_uri."src/folder_name.php\" scrolling=\"no\" name=\"folder_name\" marginheight=0 marginwidth=0 frameborder=\"$frameborder\" noresize=\"1\"/>\n";
	echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" cols=\"$left_size,*\" id=\"fs2\" name=\"fs2\">\n";
	    if ($view_contacts_main_page) {
		echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" rows=\"4%,65%,4%,*\" id=\"fs3\">\n";
		    echo "<frame src=\"".$base_uri."src/title.php?message=1&frame=left&force_refresh=TRUE\" name=\"title_folders\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 scrolling=\"no\" noresize=\"1\"/>\n";
		    echo "<frame src=\"".$base_uri."src/left_main.php\" name=\"left\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 marginheight=0 marginwidth=0 scrolling=\"yes\"/>\n";
		    echo "<frame src=\"".$base_uri."src/title.php?message=2&frame=contacts\" name=\"title_contacts\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 scrolling=\"no\" noresize=\"1\"/>\n";
		    echo "<frame src=\"".$base_uri."src/list_address.php\" name=\"contacts\" marginheight=0 marginwidth=0 frameborder=\"$frameborder\" scrolling=\"yes\"/>\n";
		echo "</frameset>\n";  
	    } else {
		echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" rows=\"4%,*\" id=\"fs3\">\n";
		    echo "<frame src=\"".$base_uri."src/title.php?message=1&frame=left&force_refresh=TRUE\" name=\"title_folders\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 scrolling=\"no\" noresize=\"1\"/>\n";
		    echo "<frame src=\"".$base_uri."src/left_main.php\" name=\"left\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 marginheight=0 marginwidth=0 scrolling=\"yes\"/>\n";
		echo "</frameset>\n";  
	    }
	    if ($view_read_body_main_page) {
		echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" rows=\"4%,40%,*\" id=\"fs4\" name=\"fs4\">\n";
	    } else {
		echo "<frameset frameborder=$framesetborder framespacing=0 border=\"1px\" bordercolor=\"#F2F3ED\" rows=\"4%,*,1%\" id=\"fs4\" name=\"fs4\">\n";
	    }
		echo "<frame src=\"".$base_uri."src/title_right.php\" name=\"title_right\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 scrolling=\"no\" noresize=\"1\"/>\n";
		echo "<frame src=\"$right_frame_url\" name=\"right\" marginheight=0 marginwidth=0 frameborder=\"$frameborder\" scrolling=\"yes\"/>\n";	
		echo "<frame src=\"".$base_uri."src/read_body.php\" name=\"message\" frameborder=\"$frameborder\" marginheight=0 marginwidth=0 scrolling=\"no\"/>\n";
	    echo "</frameset>\n";  
	echo "</frameset>\n";  
do_hook('webmail_bottom');
?>
</frameset>
</html>
