<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
/**
 * genkey_keygen.php
 * ----------------
 * GPG Key Generation page
 * Copyright (c) 2002-2003 Braverock Ventures
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * @author Joshua Vermette
 * @author Aaron Van Meerten
 * @author Brian Peterson
 *
 * $Id: genkey_keygen.php,v 1.13 2003/11/18 18:45:42 ke Exp $
 */

if (!defined (SM_PATH)){
    if (file_exists('./gpg_functions.php')){
        define (SM_PATH , '../../');
    } elseif (file_exists('../gpg_functions.php')){
        define (SM_PATH , '../../../');
    } elseif (file_exists('../plugins/gpg/gpg_functions.php')){
        define (SM_PATH , '../');
    } else echo "unable to define SM_PATH in genkey_keygen.php, exiting abnormally";
}

require_once(SM_PATH.'functions/global.php');
require_once(SM_PATH.'functions/forms.php');

//Cancelling?
sqgetGlobalVar('can', $can, SQ_POST);
sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION);


if (isset($can)) {
    if ($can) {
        //Send them back to getting started
        require_once(SM_PATH.'plugins/gpg/modules/keyring_main.php');
        exit;
    }
}

require_once(SM_PATH.'plugins/gpg/gpg_keyring.php');
require_once(SM_PATH.'plugins/gpg/gpg_functions.php');
require_once(SM_PATH.'plugins/gpg/gpg_key_functions.php');

//Check passphrases.
sqgetGlobalVar('passphrase', $passphrase, SQ_POST);
sqgetGlobalVar('passphrase2', $passphrase2, SQ_POST);
if (!$passphrase || !$passphrase2 || $passphrase != $passphrase2) {
  $err[] = codeHTML(_("Your passphrases do not match."))
         . '&nbsp;'
         . codeHTML(_("Please try again."));
  require_once(SM_PATH.'plugins/gpg/modules/genkey.php');
  exit;
}

//Are they on a secure connection?
if (!gpg_https_connection()) {
    $notSecure = true;
    require_once(SM_PATH.'plugins/gpg/modules/keyring_main.php');
    exit;
}

//include the gpg system header, so's everything will be in place.
//Have to chdir so included includes will work.
require_once(SM_PATH.'plugins/gpg/modules/gpg_module_header.php');

echo '<tr>
        <td align="left" width="100%" valign="top">
            <table width="100%" height="100%" cellpadding="0" valign="top" class="border" cellspacing="2" border="0">';

sqgetGlobalVar('pos', $pos, SQ_GET);
sqgetGlobalVar('sort', $sort, SQ_GET);
sqgetGlobalVar('desc', $desc, SQ_GET);
sqgetGlobalVar('srch', $srch, SQ_GET);
sqgetGlobalVar('ring', $ring, SQ_GET);

//Make the passthrough string for keyring_main.
$thru = ("pos=" . $pos) .
     "&sort=" . urlencode($sort) .
     "&desc=" . urlencode($desc) .
     "&srch=" . urlencode($srch) .

$ringThru = "ring=" . urlencode($ring);

sqgetGlobalVar('email_address', $email_address, SQ_POST);
sqgetGlobalVar('full_name', $full_name, SQ_POST);
sqgetGlobalVar('key_strength', $key_strength, SQ_POST);
sqgetGlobalVar('key_expires', $key_expires, SQ_POST);

ob_end_flush();
ob_start();

// ===============================================================
$section_title = _("GPG Options - Create a Personal Keypair");
gpg_page_title( $section_title );
// ===============================================================

echo '<tr valign="top"><td width="100%" height="1%" align="center" class="nav">';

    //bordo esterno
    echo  '<table cellpadding="1" cellspacing="0" border="0" width="60%">';
        echo '<tr><td bgcolor="#000000">';
    //tabella interna
    echo '<table cellpadding="3" cellspacing="1" bgcolor="#FFFFFF" border="0" width="100%">';
        //titolo
        echo '<tr><td bgcolor="#FFFFCC">';
            echo codeHTML(_("Generating Keypair based on"));
        echo '</td></tr>';
	echo '<tr><td>';
	    echo '<ul>';
		echo '<li>';
		    echo codeHTML(_("Email Address")).':&nbsp;';
		    if ($email_address) {
			echo codeHTML($email_address);
		    } else {
			echo '<font color="red">';
			echo codeHTML(_("Unassigned"));
			echo '</font>';
		    }
		echo '</li>';
		echo '<li>';
		    echo codeHTML(_("Full Name")).':&nbsp;';
		    if ($full_name) {
			echo codeHTML($full_name);
		    } else {
			echo '<font color="red">';
			echo codeHTML(_("Unassigned"));
			echo '</font>';
		    }
		echo '</li>';
		echo '<li>';
		    echo codeHTML(_("Passphrase")).':&nbsp;';
		    if ($passphrase && $passphrase2) {
			echo codeHTML(_("Assigned"));
		    } else {
			echo '<font color="red">';
			echo codeHTML(_("Unassigned"));
			echo '</font>';
		    }
		echo '</li>';
		echo '<li>';
		    echo codeHTML(_("Key Strength")).':&nbsp;';
		    echo codeHTML($key_strength);
		echo '</li>';
		echo '<li>';
		    echo codeHTML(_("Key Expires")).':&nbsp;';
		    if ($key_expires == 0) {
			echo codeHTML(_("Never"));
		    } elseif ($key_expires == '1y') {
			echo codeHTML(_("One Year"));
		    } else {
			echo codeHTML($key_expires).'&nbsp;';
			echo codeHTML(_("Days"));
		    }
		echo '</li>';
	    echo '</ul>';
	echo '</td></tr>';
	echo '<tr><td align="center">';
	    echo codeHTML(_("Your key is being generated... please be patient!"));
	    $comment=$GLOBALS['GPG_SYSTEM_OPTIONS']['default_comment'];
	    //Generate the keypair.
	    ob_end_flush();
	    ob_start();
	    $ret = gpg_generate_keypair($debug, $full_name, $email_address, $passphrase, $comment, $key_strength, $key_expires);
	echo '</td></tr>';

if (count($ret['errors'])) {
    //Set the flag.
    $keyErr = true;
    //If any of these fields is missing, we can guess at a more informative error message.
    //In any case, it might as well be the error, since nothing can work without it.
    //So only print the error(s) if they're all there.
    if ($email_address && $full_name && $passphrase && $passphrase2) {
        //Print the errror(s).
        foreach ($ret['errors'] as $error) {
            $err[] = codeHTML(_("Error: ")).codeHTML($error);
        }
    } else {
        $err[] =   '<a class="gpg" href="'.$base_uri.'plugins/gpg/modules/genkey.php">'
		 . codeHTML(_("Required data missing.")).'&nbsp;'
                 . codeHTML(_("Please"))
                 . '&nbsp;'
                 . codeHTML(_("try again"))
                 . '</a>.';
    }
    //Output any error we found.
    require_once(SM_PATH.'plugins/gpg/modules/gpg_err.php');
} else {
    echo '<tr><td>';

    //Messages?
    foreach ($ret['messages'] as $thing) {
        //echo ("<br>" . htmlspecialchars($thing));
        if (ereg("sec[[:space:]]+([[:digit:]]+[R|D|G])/([[:alnum:]]+)[[:space:]]+(.*)", $thing, $tmp))
            $key_id = $tmp[2];
    }

    //Get the key.
    //XXX - This seems hacky... isn't there a way to get the fpr back from a creation?
    $ring = new gpg_keyring();
    $err = $ring->fetchKeys($key_id, "");
    if (! $err['errors'][0]) {
        $fList = array_keys($ring->keys);
        $fpr = $fList[0];
        $key = $ring->keys[$fpr];
    }

    echo '<font size="+1">';
	echo '<b>';
	    echo codeHTML(_("Success!")).codeHTML(_("A new personal Keypair has been generated."));
	echo '</b>';
    echo '</font>';

    if ($key) {
        echo '[';
        echo "<a class=\"gpg\" href=\"".$base_uri."plugins/gpg/modules/keyview.php?fpr=$fpr&$thru&ring=secret\">";
        echo codeHTML(_("View Key"));
        echo '</a>';
        echo ']';
    }
    echo '</td></tr>';
}

echo '<tr><td align="center">';

echo '<b>';
echo '<a class="gpg" href="'.$base_uri.'plugins/gpg/modules/keyring_main.php?' . $thru . '&' . $ringThru . '">';
echo codeHTML(_("Back to Keyring Management"));
echo '</a>';
echo '</b>';

echo '</td></tr></table></td></tr></table></td></tr>';
ob_end_flush();

echo '<tr>
        <td align="left" width="100%" class="nav">
                    &nbsp;
                </td>
            </tr>';

echo '</table>';

require_once(SM_PATH.'plugins/gpg/modules/gpg_module_footer.php');

/**
 * $Log: genkey_keygen.php,v $
 * Revision 1.13  2003/11/18 18:45:42  ke
 * -fixed link to View Key (double quotes instead of single quotes)
 * -fixed equality of != rather than !==
 * -fixed friendly message during key generation
 * bug 84
 *
 * Revision 1.12  2003/11/12 16:51:58  brian
 * syntax fixes of if/else blocks
 *
 * Revision 1.11  2003/11/06 18:15:05  brian
 * fixed syntax error on line 53
 *
 * Revision 1.10  2003/11/06 18:13:48  brian
 * fixed syntax error on line 53
 *
 * Revision 1.9  2003/11/06 18:10:58  brian
 * Changed gpg_err string in line 39
 *
 * Revision 1.8  2003/11/04 21:41:01  brian
 * change to use SM_PATH
 *
 * ----------------------------
 * Manually added Log entries
 *
 * revision 1.7
 * date: 2003/11/03 19:40:35;  author: brian;  state: Exp;  lines: +1 -1
 * minor wording changes in advance of translation.
 * Bug 35
 * ----------------------------
 * revision 1.6
 * date: 2003/10/30 20:38:21;  author: brian;  state: Exp;  lines: +104 -102
 * modified all localized strings to use double quotes.
 * Bug 35
 * ----------------------------
 * revision 1.5
 * date: 2003/10/30 02:17:03;  author: walter;  state: Exp;  lines: +11 -1
 * - completed localized text by sentences
 * Bug 35
 * ----------------------------
 * revision 1.4
 * date: 2003/10/29 00:20:17;  author: walter;  state: Exp;  lines: +165 -106
 * - localized text by sentences
 * Bug 35
 * -  updated Help structure
 * Bug 79
 * ----------------------------
 * revision 1.3
 * date: 2003/10/04 00:57:39;  author: ke;  state: Exp;  lines: +1 -1
 * -Added check for contents of error array in $err instead of only return from keyring function
 * ----------------------------
 * revision 1.2
 * date: 2003/10/01 19:56:40;  author: ke;  state: Exp;  lines: +14 -4
 * -added expiration date to fields displayed after generation
 * -Changed call to gpg_generate_keypair to include expiration date and system default_comment
 * bug 61
 * ----------------------------
 * revision 1.1
 * date: 2003/08/13 07:34:05;  author: vermette;  state: Exp;
 * new key generation suite
 */
?>
